<?php
	/*	
	*	Goodlayers Framework File
	*	---------------------------------------------------------------------
	*	This file contains the homepage loading button in page option area
	*	---------------------------------------------------------------------
	*/
	
	add_action('add_meta_boxes', 'gdlr_init_demo_page_option');
	if( !function_exists('gdlr_init_demo_page_option') ){
		function gdlr_init_demo_page_option(){
			add_meta_box( 'demo-page-option', 
				__('Load Demo Page', 'gdlr_translate'), 
				'gdlr_create_demo_page_option',
				'page',
				'side',
				'default'
			);
		}
	}
	
	if( !function_exists('gdlr_create_demo_page_option') ){
		function gdlr_create_demo_page_option(){
			global $post;
		
			$buttons = array(
				'homepage-1' => __('Homepage Light', 'gdlr_translate'),
				'homepage-2' => __('Homepage Dark', 'gdlr_translate'),
				'homepage-3' => __('Homepage Modern', 'gdlr_translate'),
				'homepage-4' => __('Homepage Hostel', 'gdlr_translate'),
				'homepage-5' => __('Homepage Apartment', 'gdlr_translate'),
				'about' => __('About Us', 'gdlr_translate'),
				'contact-1' => __('Contact 1', 'gdlr_translate'),
				'contact-2' => __('Contact 2', 'gdlr_translate'),
				'branches' => __('Branches', 'gdlr_translate'),
				'service-facilities' => __('Service & Facilities', 'gdlr_translate'),
			);
			
			echo '<div id="gdlr-load-demo-wrapper" data-ajax="' . AJAX_URL . '" data-id="' . $post->ID . '" data-action="load_demo_pagebuilder">';
			echo '<em>';
			echo __('*This option allow you to set page item to following pages with one click. Note that to use this option will replace all your current page item setting in this page and <strong>This Can\'t Be Undone</strong>. ( Images are not included. )', 'gdlr_translate');
			echo '</em><div class="clear"></div>';
			foreach( $buttons as $button_slug => $button_title ){
				echo '<input type="button" data-slug="' . $button_slug . '" value="' . $button_title . '" />';
			}
			echo '</div>';

		}
	}
	
	add_action('wp_ajax_load_demo_pagebuilder', 'gdlr_load_demo_pagebuilder');
	if( !function_exists('gdlr_load_demo_pagebuilder') ){
		function gdlr_load_demo_pagebuilder(){
			$default_data = array(
				'homepage-1' => array(
					'above-sidebar'=>'[]',
					'below-sidebar'=>'[]',
					'content-with-sidebar'=>'[{"item-type":"wrapper","item-builder-title":"Full Size Wrapper","type":"full-size-wrapper","items":[{"item-type":"item","item-builder-title":"Master Slider","type":"master-slider","option":{"page-item-id":"","id":"1","margin-bottom":"0px"}}],"option":{"page-item-id":"","background":"#ffffff","show-section":"gdlr-show-all","border":"none","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"0px","padding-bottom":"0px"}},{"item-type":"wrapper","item-builder-title":"Color Wrapper","type":"color-wrapper","items":[{"item-type":"item","item-builder-title":"Room","type":"room","option":{"page-item-id":"","title-type":"center","title":"Hotel Master\'s Rooms","caption":"","right-text":"View All Rooms","right-text-link":"http://themes.goodlayers2.com/hotelmaster/room-classic-3-columns/","category":"room","tag":"","room-style":"modern","enable-carousel":"enable","room-size":"3","num-fetch":"8","num-excerpt":"20","thumbnail-size":"blog-grid","orderby":"date","order":"desc","pagination":"disable","margin-bottom":"0px"}}],"option":{"page-item-id":"","background-type":"color","background":"#ffffff","skin":"no-skin","show-section":"gdlr-show-all","border":"none","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"80px","padding-bottom":"10px"}},{"item-type":"wrapper","item-builder-title":"Color Wrapper","type":"color-wrapper","items":[{"item-type":"item","item-builder-title":"Hotel Availability","type":"hotel-availability","option":{"page-item-id":"","title-type":"center","title":"Check Abailability","caption":"","right-text":"Read All News","right-text-link":"","margin-bottom":"20px"}}],"option":{"page-item-id":"","background-type":"color","background":"#f5f5f5","skin":"gdlr-skin-light-grey","show-section":"gdlr-show-all","border":"none","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"70px","padding-bottom":"50px"}},{"item-type":"wrapper","item-builder-title":"Color Wrapper","type":"color-wrapper","items":[{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-3","items":[{"item-type":"item","item-builder-title":"Gallery","type":"gallery","option":{"page-item-id":"","slider":"[[3518,3519,3521,3517,3514,3512,3511,3523,3525],{|gq2|3511|gq2|:{|gq2|title|gq2|:|gq2||gq2|,|gq2|caption|gq2|:|gq2||gq2|,|gq2|caption-position|gq2|:|gq2||gq2|,|gq2|slide-link|gq2|:|gq2|current|gq2|,|gq2|url|gq2|:|gq2||gq2|,|gq2|new-tab|gq2|:|gq2|enable|gq2|,|gq2|thumbnail|gq2|:|gq2|http://themes.goodlayers2.com/hotelmaster/wp-content/uploads/2015/03/photodune-2676493-suite-bed-room-with-balcony-of-a-luxury-resort-m-150x150.jpg|gq2|,|gq2|width|gq2|:150,|gq2|height|gq2|:150},|gq2|3512|gq2|:{|gq2|title|gq2|:|gq2||gq2|,|gq2|caption|gq2|:|gq2||gq2|,|gq2|caption-position|gq2|:|gq2||gq2|,|gq2|slide-link|gq2|:|gq2|current|gq2|,|gq2|url|gq2|:|gq2||gq2|,|gq2|new-tab|gq2|:|gq2|enable|gq2|,|gq2|thumbnail|gq2|:|gq2|http://themes.goodlayers2.com/hotelmaster/wp-content/uploads/2015/03/photodune-3973259-hotel-room-m-150x150.jpg|gq2|,|gq2|width|gq2|:150,|gq2|height|gq2|:150},|gq2|3514|gq2|:{|gq2|title|gq2|:|gq2||gq2|,|gq2|caption|gq2|:|gq2||gq2|,|gq2|caption-position|gq2|:|gq2||gq2|,|gq2|slide-link|gq2|:|gq2|current|gq2|,|gq2|url|gq2|:|gq2||gq2|,|gq2|new-tab|gq2|:|gq2|enable|gq2|,|gq2|thumbnail|gq2|:|gq2|http://themes.goodlayers2.com/hotelmaster/wp-content/uploads/2015/03/photodune-4076311-interior-of-modern-comfortable-hotel-room-m-150x150.jpg|gq2|,|gq2|width|gq2|:150,|gq2|height|gq2|:150},|gq2|3517|gq2|:{|gq2|title|gq2|:|gq2||gq2|,|gq2|caption|gq2|:|gq2||gq2|,|gq2|caption-position|gq2|:|gq2||gq2|,|gq2|slide-link|gq2|:|gq2|current|gq2|,|gq2|url|gq2|:|gq2||gq2|,|gq2|new-tab|gq2|:|gq2|enable|gq2|,|gq2|thumbnail|gq2|:|gq2|http://themes.goodlayers2.com/hotelmaster/wp-content/uploads/2015/03/photodune-2650397-sailing-m-150x150.jpg|gq2|,|gq2|width|gq2|:150,|gq2|height|gq2|:150},|gq2|3518|gq2|:{|gq2|title|gq2|:|gq2||gq2|,|gq2|caption|gq2|:|gq2||gq2|,|gq2|caption-position|gq2|:|gq2||gq2|,|gq2|slide-link|gq2|:|gq2|current|gq2|,|gq2|url|gq2|:|gq2||gq2|,|gq2|new-tab|gq2|:|gq2|enable|gq2|,|gq2|thumbnail|gq2|:|gq2|http://themes.goodlayers2.com/hotelmaster/wp-content/uploads/2015/03/photodune-7751505-luxury-home-with-swimming-pool-m-150x150.jpg|gq2|,|gq2|width|gq2|:150,|gq2|height|gq2|:150},|gq2|3519|gq2|:{|gq2|title|gq2|:|gq2||gq2|,|gq2|caption|gq2|:|gq2||gq2|,|gq2|caption-position|gq2|:|gq2||gq2|,|gq2|slide-link|gq2|:|gq2|current|gq2|,|gq2|url|gq2|:|gq2||gq2|,|gq2|new-tab|gq2|:|gq2|enable|gq2|,|gq2|thumbnail|gq2|:|gq2|http://themes.goodlayers2.com/hotelmaster/wp-content/uploads/2015/03/photodune-1231437-tropical-pool-bar-m-150x150.jpg|gq2|,|gq2|width|gq2|:150,|gq2|height|gq2|:150},|gq2|3521|gq2|:{|gq2|title|gq2|:|gq2||gq2|,|gq2|caption|gq2|:|gq2||gq2|,|gq2|caption-position|gq2|:|gq2||gq2|,|gq2|slide-link|gq2|:|gq2|current|gq2|,|gq2|url|gq2|:|gq2||gq2|,|gq2|new-tab|gq2|:|gq2|enable|gq2|,|gq2|thumbnail|gq2|:|gq2|http://themes.goodlayers2.com/hotelmaster/wp-content/uploads/2015/03/photodune-1576481-relaxing-m-150x150.jpg|gq2|,|gq2|width|gq2|:150,|gq2|height|gq2|:150},|gq2|3523|gq2|:{|gq2|title|gq2|:|gq2||gq2|,|gq2|caption|gq2|:|gq2||gq2|,|gq2|caption-position|gq2|:|gq2||gq2|,|gq2|slide-link|gq2|:|gq2|current|gq2|,|gq2|url|gq2|:|gq2||gq2|,|gq2|new-tab|gq2|:|gq2|enable|gq2|,|gq2|thumbnail|gq2|:|gq2|http://themes.goodlayers2.com/hotelmaster/wp-content/uploads/2015/03/Fotolia_34317913_Subscription_Monthly_XXL-150x150.jpg|gq2|,|gq2|width|gq2|:150,|gq2|height|gq2|:150},|gq2|3525|gq2|:{|gq2|title|gq2|:|gq2||gq2|,|gq2|caption|gq2|:|gq2||gq2|,|gq2|caption-position|gq2|:|gq2||gq2|,|gq2|slide-link|gq2|:|gq2|current|gq2|,|gq2|url|gq2|:|gq2||gq2|,|gq2|new-tab|gq2|:|gq2|enable|gq2|,|gq2|thumbnail|gq2|:|gq2|http://themes.goodlayers2.com/hotelmaster/wp-content/uploads/2015/03/Fotolia_44778217_Subscription_Monthly_XXL-150x150.jpg|gq2|,|gq2|width|gq2|:150,|gq2|height|gq2|:150}}]","title-type":"left-divider","title":"Gallery","caption":"","thumbnail-size":"round-personnel-size","gallery-style":"grid","with-featured":"","gallery-columns":"3","num-fetch":"","show-caption":"no","margin-bottom":"20px"}}],"option":{},"size":"1/3"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-3","items":[{"item-type":"item","item-builder-title":"Title","type":"title","option":{"page-item-id":"","title-type":"left-divider","title":"Video Tour","caption":"","right-text":"Read All News","right-text-link":"","margin-bottom":"40px"}},{"item-type":"item","item-builder-title":"Video","type":"video","option":{"page-item-id":"","title-type":"none","title":"","caption":"","url":"https://vimeo.com/56815898","content-title":"Sollicitudin Sit Inceptos","content":"Donec sed odio dui. Maecenas faucibus mollis interdum. Aenean lacinia bibendum nulla sed consectetur. Donec sed odio dui. Maecenas faucibus mollis interdum.","margin-bottom":"20px"}}],"option":{},"size":"1/3"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-3","items":[{"item-type":"item","item-builder-title":"Blog","type":"blog","option":{"page-item-id":"","title-type":"left-divider","title":"News From Us","caption":"","right-text":"Read All News","right-text-link":"http://themes.goodlayers2.com/hotelmaster/blog-3-columns/","category":"blog","tag":"","num-excerpt":"7","num-fetch":"3","blog-style":"blog-widget","blog-layout":"fitRows","thumbnail-size":"thumbnail","orderby":"date","order":"desc","offset":"","pagination":"disable","enable-sticky":"disable","margin-bottom":"0px"}}],"option":{},"size":"1/3"}],"option":{"page-item-id":"","background-type":"","background":"#ffffff","skin":"","show-section":"","border":"","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"70px","padding-bottom":"40px"}},{"item-type":"wrapper","item-builder-title":"Background/Parallax Wrapper","type":"parallax-bg-wrapper","items":[{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-2","items":[{"item-type":"item","item-builder-title":"Service With Image","type":"service-with-image","option":{"page-item-id":"","image":"3747","thumbnail-size":"round-personnel-size","align":"left","title":"A little about us","content":"<p>Morbi leo risus, porta ac consectetur ac, vesti bulum at eros. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh, ut fermentum massa justo sit amet risus. Lorem ipsum dolor sit amet, consectetur.</p>","margin-bottom":"20px"}}],"option":{},"size":"1/2"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-2","items":[{"item-type":"item","item-builder-title":"Service With Image","type":"service-with-image","option":{"page-item-id":"","image":"3746","thumbnail-size":"round-personnel-size","align":"left","title":"Travel plan mag","content":"<p>Morbi leo risus, porta ac consectetur ac, vesti bulum at eros. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh, ut fermentum massa justo sit amet risus. Lorem ipsum dolor sit amet, consectetur.</p>","margin-bottom":"20px"}}],"option":{},"size":"1/2"}],"option":{"page-item-id":"","type":"image","background":"3738","background-mobile":"","background-speed":"0","pattern":"1","video":"","video-overlay":"0.5","video-player":"enable","skin":"no-skin","show-section":"gdlr-show-all","border":"none","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"95px","padding-bottom":"40px"}},{"item-type":"wrapper","item-builder-title":"Color Wrapper","type":"color-wrapper","items":[{"item-type":"item","item-builder-title":"Testimonial","type":"testimonial","option":{"page-item-id":"","testimonial":"[{|gq2|gdl-tab-author-image-url|gq2|:|gq2||gq2|,|gq2|gdl-tab-author-image|gq2|:|gq2||gq2|,|gq2|gdl-tab-title|gq2|:|gq2|Angelina Cole|gq2|,|gq2|gdl-tab-position|gq2|:|gq2|Traveller|gq2|,|gq2|gdl-tab-content|gq2|:|gq2|Lorem ipsum dolor sit amet, consectetur adipiscing elit. Etiam porta sem malesuada magna mollis euismod. Nul id dolor id nibh ultricies vehicula ut id elit. Nullam quis risus eget urna mollis ornare vel eu leo.|gq2|},{|gq2|gdl-tab-author-image-url|gq2|:|gq2||gq2|,|gq2|gdl-tab-author-image|gq2|:|gq2||gq2|,|gq2|gdl-tab-title|gq2|:|gq2|John Smith|gq2|,|gq2|gdl-tab-position|gq2|:|gq2|Businesman|gq2|,|gq2|gdl-tab-content|gq2|:|gq2|Lorem ipsum dolor sit amet, consectetur adipiscing elit. Etiam porta sem malesuada magna mollis euismod. Nul id dolor id nibh ultricies vehicula ut id elit. Nullam quis risus eget urna mollis ornare vel eu leo. Donec id elit non mi porta.|gq2|},{|gq2|gdl-tab-author-image-url|gq2|:|gq2||gq2|,|gq2|gdl-tab-author-image|gq2|:|gq2||gq2|,|gq2|gdl-tab-title|gq2|:|gq2|Pam Pamelar|gq2|,|gq2|gdl-tab-position|gq2|:|gq2|Traveller|gq2|,|gq2|gdl-tab-content|gq2|:|gq2|Lorem ipsum dolor sit amet, consectetur adipiscing elit. Etiam porta sem malesuada magna mollis euismod. Nul id dolor id nibh ultricies vehicula ut id elit. Nullam quis risus eget urna mollis ornare leo.|gq2|}]","title-type":"center","title":"Testimonial","caption":"","testimonial-columns":"1","testimonial-type":"carousel","testimonial-style":"large plain-style","margin-bottom":"20px"}}],"option":{"page-item-id":"","background-type":"color","background":"#ffffff","skin":"no-skin","show-section":"gdlr-show-all","border":"none","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"80px","padding-bottom":"45px"}}]',
					'post-option'=>'{"sidebar":"no-sidebar","left-sidebar":"Footer 1","right-sidebar":"Footer 1","page-style":"normal","show-title":"disable","page-caption":"","show-content":"enable","header-background":""}'
				),
				'homepage-2' => array(
					'above-sidebar'=>'[]',
					'below-sidebar'=>'[]',
					'content-with-sidebar'=>'[{"item-type":"wrapper","item-builder-title":"Full Size Wrapper","type":"full-size-wrapper","items":[{"item-type":"item","item-builder-title":"Master Slider","type":"master-slider","option":{"page-item-id":"","id":"2","margin-bottom":"0px"}}],"option":{"page-item-id":"","background":"#ffffff","show-section":"gdlr-show-all","border":"none","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"0px","padding-bottom":"0px"}},{"item-type":"wrapper","item-builder-title":"Color Wrapper","type":"color-wrapper","items":[{"item-type":"item","item-builder-title":"Hotel Availability","type":"hotel-availability","option":{"page-item-id":"","title-type":"none","title":"Check Abailability","caption":"","right-text":"Read All News","right-text-link":"","margin-bottom":"20px"}}],"option":{"page-item-id":"","background-type":"color","background":"#322b23","skin":"gdlr-skin-dark-brown","show-section":"gdlr-show-all","border":"none","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"48px","padding-bottom":"27px"}},{"item-type":"wrapper","item-builder-title":"Color Wrapper","type":"color-wrapper","items":[{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-3","items":[{"item-type":"item","item-builder-title":"Column Service","type":"column-service","option":{"page-item-id":"","type":"image","image":"3952","icon":"","title":"Perfect For Relaxing","style":"type-2","content":"<p>Cum sociis natoque penatibus et magnis dis part urient montes, nascetur ridiculus mus. Vestib ulum id ligula porta felis euis.</p>","margin-bottom":"20px"}}],"option":{},"size":"1/3"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-3","items":[{"item-type":"item","item-builder-title":"Column Service","type":"column-service","option":{"page-item-id":"","type":"image","image":"3953","icon":"","title":"Luxury Rooms","style":"type-2","content":"<p>Cum sociis natoque penatibus et magnis dis part urient montes, nascetur ridiculus mus. Vestib ulum id ligula porta felis euis.</p>","margin-bottom":"20px"}}],"option":{},"size":"1/3"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-3","items":[{"item-type":"item","item-builder-title":"Column Service","type":"column-service","option":{"page-item-id":"","type":"image","image":"3954","icon":"","title":"Best for dining","style":"type-2","content":"<p>Cum sociis natoque penatibus et magnis dis part urient montes, nascetur ridiculus mus. Vestib ulum id ligula porta felis euis.</p>","margin-bottom":"20px"}}],"option":{},"size":"1/3"}],"option":{"page-item-id":"","background-type":"color","background":"#0a0a0a","skin":"no-skin","show-section":"gdlr-show-all","border":"none","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"60px","padding-bottom":"40px"}},{"item-type":"wrapper","item-builder-title":"Background/Parallax Wrapper","type":"parallax-bg-wrapper","items":[{"item-type":"item","item-builder-title":"Room","type":"room","option":{"page-item-id":"","title-type":"center","title":"Hotel Master\'s Rooms","caption":"","right-text":"View All Rooms","right-text-link":"http://themes.goodlayers2.com/hotelmaster/room-classic-3-columns/","category":"room","tag":"","room-style":"modern","enable-carousel":"enable","room-size":"3","num-fetch":"8","num-excerpt":"20","thumbnail-size":"blog-grid","orderby":"date","order":"desc","pagination":"disable","margin-bottom":"0px"}}],"option":{"page-item-id":"","type":"image","background":"3959","background-mobile":"","background-speed":"0.1","pattern":"1","video":"","video-overlay":"0.5","video-player":"enable","skin":"gdlr-skin-light-grey","show-section":"gdlr-show-all","border":"none","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"80px","padding-bottom":"10px"}},{"item-type":"wrapper","item-builder-title":"Background/Parallax Wrapper","type":"parallax-bg-wrapper","items":[{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-2","items":[{"item-type":"item","item-builder-title":"Title","type":"title","option":{"page-item-id":"","title-type":"center-divider","title":"A Little About Us","caption":"Inspiration can be found everywhere","right-text":"Read All News","right-text-link":"","margin-bottom":"20px"}}],"option":{},"size":"1/2"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-2","items":[{"item-type":"item","item-builder-title":"Content","type":"content","option":{"page-item-id":"","title-type":"none","title":"","caption":"","right-text":"Read All News","right-text-link":"","content":"<p style=|gq2|text-align: center;|gq2|>Morbi leo risus, porta ac consectetur ac, vestibulum at eros. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh, ut fermentum massa justo sit amet risus. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Donec id elit non mi porta gravida at eget metus. Praesent commodo cursus magna, vel scelerisque nisl consectetur et.</p>","margin-bottom":"20px"}}],"option":{},"size":"1/2"}],"option":{"page-item-id":"","type":"image","background":"3962","background-mobile":"","background-speed":"0.1","pattern":"1","video":"","video-overlay":"0.5","video-player":"enable","skin":"gdlr-skin-dark-skin","show-section":"gdlr-show-all","border":"none","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"160px","padding-bottom":"110px"}},{"item-type":"wrapper","item-builder-title":"Color Wrapper","type":"color-wrapper","items":[{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-3","items":[{"item-type":"item","item-builder-title":"Blog","type":"blog","option":{"page-item-id":"","title-type":"left-divider","title":"News From Us","caption":"","right-text":"Read All News","right-text-link":"http://themes.goodlayers2.com/hotelmaster/blog-3-columns/","category":"blog","tag":"","num-excerpt":"14","num-fetch":"3","blog-style":"blog-widget","blog-layout":"fitRows","thumbnail-size":"thumbnail","orderby":"date","order":"desc","offset":"","pagination":"disable","enable-sticky":"disable","margin-bottom":"0px"}}],"option":{},"size":"1/2"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-3","items":[{"item-type":"item","item-builder-title":"Gallery","type":"gallery","option":{"page-item-id":"","slider":"[[3518,3519,3521,3517,3514,3512,3511,3523,3525],{|gq2|3511|gq2|:{|gq2|title|gq2|:|gq2||gq2|,|gq2|caption|gq2|:|gq2||gq2|,|gq2|caption-position|gq2|:|gq2||gq2|,|gq2|slide-link|gq2|:|gq2|current|gq2|,|gq2|url|gq2|:|gq2||gq2|,|gq2|new-tab|gq2|:|gq2|enable|gq2|,|gq2|thumbnail|gq2|:|gq2|http://themes.goodlayers2.com/hotelmaster/wp-content/uploads/2015/03/photodune-2676493-suite-bed-room-with-balcony-of-a-luxury-resort-m-150x150.jpg|gq2|,|gq2|width|gq2|:150,|gq2|height|gq2|:150},|gq2|3512|gq2|:{|gq2|title|gq2|:|gq2||gq2|,|gq2|caption|gq2|:|gq2||gq2|,|gq2|caption-position|gq2|:|gq2||gq2|,|gq2|slide-link|gq2|:|gq2|current|gq2|,|gq2|url|gq2|:|gq2||gq2|,|gq2|new-tab|gq2|:|gq2|enable|gq2|,|gq2|thumbnail|gq2|:|gq2|http://themes.goodlayers2.com/hotelmaster/wp-content/uploads/2015/03/photodune-3973259-hotel-room-m-150x150.jpg|gq2|,|gq2|width|gq2|:150,|gq2|height|gq2|:150},|gq2|3514|gq2|:{|gq2|title|gq2|:|gq2||gq2|,|gq2|caption|gq2|:|gq2||gq2|,|gq2|caption-position|gq2|:|gq2||gq2|,|gq2|slide-link|gq2|:|gq2|current|gq2|,|gq2|url|gq2|:|gq2||gq2|,|gq2|new-tab|gq2|:|gq2|enable|gq2|,|gq2|thumbnail|gq2|:|gq2|http://themes.goodlayers2.com/hotelmaster/wp-content/uploads/2015/03/photodune-4076311-interior-of-modern-comfortable-hotel-room-m-150x150.jpg|gq2|,|gq2|width|gq2|:150,|gq2|height|gq2|:150},|gq2|3517|gq2|:{|gq2|title|gq2|:|gq2||gq2|,|gq2|caption|gq2|:|gq2||gq2|,|gq2|caption-position|gq2|:|gq2||gq2|,|gq2|slide-link|gq2|:|gq2|current|gq2|,|gq2|url|gq2|:|gq2||gq2|,|gq2|new-tab|gq2|:|gq2|enable|gq2|,|gq2|thumbnail|gq2|:|gq2|http://themes.goodlayers2.com/hotelmaster/wp-content/uploads/2015/03/photodune-2650397-sailing-m-150x150.jpg|gq2|,|gq2|width|gq2|:150,|gq2|height|gq2|:150},|gq2|3518|gq2|:{|gq2|title|gq2|:|gq2||gq2|,|gq2|caption|gq2|:|gq2||gq2|,|gq2|caption-position|gq2|:|gq2||gq2|,|gq2|slide-link|gq2|:|gq2|current|gq2|,|gq2|url|gq2|:|gq2||gq2|,|gq2|new-tab|gq2|:|gq2|enable|gq2|,|gq2|thumbnail|gq2|:|gq2|http://themes.goodlayers2.com/hotelmaster/wp-content/uploads/2015/03/photodune-7751505-luxury-home-with-swimming-pool-m-150x150.jpg|gq2|,|gq2|width|gq2|:150,|gq2|height|gq2|:150},|gq2|3519|gq2|:{|gq2|title|gq2|:|gq2||gq2|,|gq2|caption|gq2|:|gq2||gq2|,|gq2|caption-position|gq2|:|gq2||gq2|,|gq2|slide-link|gq2|:|gq2|current|gq2|,|gq2|url|gq2|:|gq2||gq2|,|gq2|new-tab|gq2|:|gq2|enable|gq2|,|gq2|thumbnail|gq2|:|gq2|http://themes.goodlayers2.com/hotelmaster/wp-content/uploads/2015/03/photodune-1231437-tropical-pool-bar-m-150x150.jpg|gq2|,|gq2|width|gq2|:150,|gq2|height|gq2|:150},|gq2|3521|gq2|:{|gq2|title|gq2|:|gq2||gq2|,|gq2|caption|gq2|:|gq2||gq2|,|gq2|caption-position|gq2|:|gq2||gq2|,|gq2|slide-link|gq2|:|gq2|current|gq2|,|gq2|url|gq2|:|gq2||gq2|,|gq2|new-tab|gq2|:|gq2|enable|gq2|,|gq2|thumbnail|gq2|:|gq2|http://themes.goodlayers2.com/hotelmaster/wp-content/uploads/2015/03/photodune-1576481-relaxing-m-150x150.jpg|gq2|,|gq2|width|gq2|:150,|gq2|height|gq2|:150},|gq2|3523|gq2|:{|gq2|title|gq2|:|gq2||gq2|,|gq2|caption|gq2|:|gq2||gq2|,|gq2|caption-position|gq2|:|gq2||gq2|,|gq2|slide-link|gq2|:|gq2|current|gq2|,|gq2|url|gq2|:|gq2||gq2|,|gq2|new-tab|gq2|:|gq2|enable|gq2|,|gq2|thumbnail|gq2|:|gq2|http://themes.goodlayers2.com/hotelmaster/wp-content/uploads/2015/03/Fotolia_34317913_Subscription_Monthly_XXL-150x150.jpg|gq2|,|gq2|width|gq2|:150,|gq2|height|gq2|:150},|gq2|3525|gq2|:{|gq2|title|gq2|:|gq2||gq2|,|gq2|caption|gq2|:|gq2||gq2|,|gq2|caption-position|gq2|:|gq2||gq2|,|gq2|slide-link|gq2|:|gq2|current|gq2|,|gq2|url|gq2|:|gq2||gq2|,|gq2|new-tab|gq2|:|gq2|enable|gq2|,|gq2|thumbnail|gq2|:|gq2|http://themes.goodlayers2.com/hotelmaster/wp-content/uploads/2015/03/Fotolia_44778217_Subscription_Monthly_XXL-150x150.jpg|gq2|,|gq2|width|gq2|:150,|gq2|height|gq2|:150}}]","title-type":"left-divider","title":"Gallery","caption":"","thumbnail-size":"round-personnel-size","gallery-style":"grid","with-featured":"enable","gallery-columns":"4","num-fetch":"","show-caption":"no","margin-bottom":"20px"}}],"option":{},"size":"1/2"}],"option":{"page-item-id":"","background-type":"color","background":"#292929","skin":"no-skin","show-section":"gdlr-show-all","border":"none","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"70px","padding-bottom":"40px"}},{"item-type":"wrapper","item-builder-title":"Color Wrapper","type":"color-wrapper","items":[{"item-type":"item","item-builder-title":"Testimonial","type":"testimonial","option":{"page-item-id":"","testimonial":"[{|gq2|gdl-tab-author-image-url|gq2|:|gq2||gq2|,|gq2|gdl-tab-author-image|gq2|:|gq2||gq2|,|gq2|gdl-tab-title|gq2|:|gq2|Angelina Cole|gq2|,|gq2|gdl-tab-position|gq2|:|gq2|Traveller|gq2|,|gq2|gdl-tab-content|gq2|:|gq2|Lorem ipsum dolor sit amet, consectetur adipiscing elit. Etiam porta sem malesuada magna mollis euismod. Nul id dolor id nibh ultricies vehicula ut id elit. Nullam quis risus eget urna mollis ornare vel eu leo.|gq2|},{|gq2|gdl-tab-author-image-url|gq2|:|gq2||gq2|,|gq2|gdl-tab-author-image|gq2|:|gq2||gq2|,|gq2|gdl-tab-title|gq2|:|gq2|John Smith|gq2|,|gq2|gdl-tab-position|gq2|:|gq2|Businesman|gq2|,|gq2|gdl-tab-content|gq2|:|gq2|Lorem ipsum dolor sit amet, consectetur adipiscing elit. Etiam porta sem malesuada magna mollis euismod. Nul id dolor id nibh ultricies vehicula ut id elit. Nullam quis risus eget urna mollis ornare vel eu leo. Donec id elit non mi porta.|gq2|},{|gq2|gdl-tab-author-image-url|gq2|:|gq2||gq2|,|gq2|gdl-tab-author-image|gq2|:|gq2||gq2|,|gq2|gdl-tab-title|gq2|:|gq2|Pam Pamelar|gq2|,|gq2|gdl-tab-position|gq2|:|gq2|Traveller|gq2|,|gq2|gdl-tab-content|gq2|:|gq2|Lorem ipsum dolor sit amet, consectetur adipiscing elit. Etiam porta sem malesuada magna mollis euismod. Nul id dolor id nibh ultricies vehicula ut id elit. Nullam quis risus eget urna mollis ornare leo.|gq2|}]","title-type":"center","title":"Testimonial","caption":"","testimonial-columns":"1","testimonial-type":"carousel","testimonial-style":"large plain-style","margin-bottom":"20px"}}],"option":{"page-item-id":"","background-type":"color","background":"#1e1e1e","skin":"gdlr-skin-dark-testimonial","show-section":"gdlr-show-all","border":"none","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"80px","padding-bottom":"45px"}}]',
					'post-option'=>'{"sidebar":"no-sidebar","left-sidebar":"Footer 1","right-sidebar":"Footer 1","page-style":"normal","show-title":"disable","page-caption":"","show-content":"enable","header-background":""}'
				),
				'homepage-3' => array(
					'above-sidebar'=>'[]',
					'below-sidebar'=>'[]',
					'content-with-sidebar'=>'[{"item-type":"wrapper","item-builder-title":"Full Size Wrapper","type":"full-size-wrapper","items":[{"item-type":"item","item-builder-title":"Master Slider","type":"master-slider","option":{"page-item-id":"","id":"5","margin-bottom":"0px"}}],"option":{"page-item-id":"","background":"#ffffff","show-section":"gdlr-show-all","border":"none","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"0px","padding-bottom":"0px"}},{"item-type":"wrapper","item-builder-title":"Color Wrapper","type":"color-wrapper","items":[{"item-type":"item","item-builder-title":"Hotel Availability","type":"hotel-availability","option":{"page-item-id":"","title-type":"center","title":"Check Abailability","caption":"","right-text":"Read All News","right-text-link":"","margin-bottom":"20px"}}],"option":{"page-item-id":"","background-type":"color","background":"#f5f5f5","skin":"gdlr-skin-light-grey","show-section":"gdlr-show-all","border":"none","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"70px","padding-bottom":"50px"}},{"item-type":"wrapper","item-builder-title":"Color Wrapper","type":"color-wrapper","items":[{"item-type":"item","item-builder-title":"Page","type":"page","option":{"page-item-id":"","title-type":"center","title":"Our Hotel Branches","caption":"","right-text":"Read All News","right-text-link":"","category":"all-branches","page-style":"hotel","item-size":"1/3","num-fetch":"8","page-layout":"fitRows","thumbnail-size":"blog-grid","pagination":"disable","margin-bottom":"0px"}}],"option":{"page-item-id":"","background-type":"color","background":"#ffffff","skin":"no-skin","show-section":"gdlr-show-all","border":"none","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"75px","padding-bottom":"40px"}},{"item-type":"wrapper","item-builder-title":"Background/Parallax Wrapper","type":"parallax-bg-wrapper","items":[{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-2","items":[{"item-type":"item","item-builder-title":"Service With Image","type":"service-with-image","option":{"page-item-id":"","image":"3746","thumbnail-size":"round-personnel-size","align":"left","title":"Travel plan mag","content":"<p>Morbi leo risus, porta ac consectetur ac, vesti bulum at eros. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh, ut fermentum massa justo sit amet risus. Lorem ipsum dolor sit amet, consectetur.</p>","margin-bottom":"20px"}}],"option":{},"size":"1/2"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-3","items":[{"item-type":"item","item-builder-title":"Page","type":"page","option":{"page-item-id":"","title-type":"","title":"","caption":"","right-text":"Read All News","right-text-link":"","category":"","page-style":"","item-size":"1/3","num-fetch":"8","page-layout":"","thumbnail-size":"","pagination":"","margin-bottom":"0px"}},{"item-type":"item","item-builder-title":"Service With Image","type":"service-with-image","option":{"page-item-id":"","image":"3751","thumbnail-size":"round-personnel-size","align":"left","title":"Travel Plan MAg!","content":"<p>Morbi leo risus, porta ac consectetur ac, vesti bulum at eros. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh, ut fermentum massa justo sit amet risus. Lorem ipsum dolor sit amet, consectetur.</p>","margin-bottom":"20px"}}],"option":{},"size":"1/2"}],"option":{"page-item-id":"","type":"image","background":"3968","background-mobile":"","background-speed":"0.1","pattern":"1","video":"","video-overlay":"0.5","video-player":"enable","skin":"gdlr-skin-dark-skin","show-section":"gdlr-show-all","border":"none","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"135px","padding-bottom":"80px"}},{"item-type":"wrapper","item-builder-title":"Color Wrapper","type":"color-wrapper","items":[{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-5","items":[],"option":{},"size":"1/5"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-5","items":[{"item-type":"item","item-builder-title":"Testimonial","type":"testimonial","option":{"page-item-id":"","testimonial":"[{|gq2|gdl-tab-author-image-url|gq2|:|gq2||gq2|,|gq2|gdl-tab-author-image|gq2|:|gq2||gq2|,|gq2|gdl-tab-title|gq2|:|gq2|Angelina Cole|gq2|,|gq2|gdl-tab-position|gq2|:|gq2|Traveller|gq2|,|gq2|gdl-tab-content|gq2|:|gq2|Lorem ipsum dolor sit amet, consectetur adipiscing elit. Etiam porta sem malesuada magna mollis euismod. Nul id dolor id nibh ultricies vehicula ut id elit. Nullam quis risus eget urna mollis ornare vel eu leo.|gq2|},{|gq2|gdl-tab-author-image-url|gq2|:|gq2||gq2|,|gq2|gdl-tab-author-image|gq2|:|gq2||gq2|,|gq2|gdl-tab-title|gq2|:|gq2|John Smith|gq2|,|gq2|gdl-tab-position|gq2|:|gq2|Businesman|gq2|,|gq2|gdl-tab-content|gq2|:|gq2|Lorem ipsum dolor sit amet, consectetur adipiscing elit. Etiam porta sem malesuada magna mollis euismod. Nul id dolor id nibh ultricies vehicula ut id elit. Nullam quis risus eget urna mollis ornare vel eu leo. Donec id elit non mi porta.|gq2|},{|gq2|gdl-tab-author-image-url|gq2|:|gq2||gq2|,|gq2|gdl-tab-author-image|gq2|:|gq2||gq2|,|gq2|gdl-tab-title|gq2|:|gq2|Pam Pamelar|gq2|,|gq2|gdl-tab-position|gq2|:|gq2|Traveller|gq2|,|gq2|gdl-tab-content|gq2|:|gq2|Lorem ipsum dolor sit amet, consectetur adipiscing elit. Etiam porta sem malesuada magna mollis euismod. Nul id dolor id nibh ultricies vehicula ut id elit. Nullam quis risus eget urna mollis ornare leo.|gq2|}]","title-type":"center","title":"Testimonial","caption":"","testimonial-columns":"1","testimonial-type":"carousel","testimonial-style":"large plain-style","margin-bottom":"20px"}}],"option":{},"size":"3/5"}],"option":{"page-item-id":"","background-type":"color","background":"#ff8432","skin":"gdlr-skin-dark-testimonial","show-section":"gdlr-show-all","border":"none","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"75px","padding-bottom":"40px"}},{"item-type":"wrapper","item-builder-title":"Color Wrapper","type":"color-wrapper","items":[{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-2","items":[{"item-type":"item","item-builder-title":"Blog","type":"blog","option":{"page-item-id":"","title-type":"left-divider","title":"Recent News","caption":"","right-text":"Read All News","right-text-link":"","category":"fit-row","tag":"","num-excerpt":"25","num-fetch":"4","blog-style":"blog-medium","blog-layout":"fitRows","thumbnail-size":"blog-grid","orderby":"date","order":"desc","offset":"","pagination":"disable","enable-sticky":"disable","margin-bottom":"0px"}}],"option":{},"size":"2/3"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-3","items":[{"item-type":"item","item-builder-title":"Title","type":"title","option":{"page-item-id":"","title-type":"left-divider","title":"Video Tour","caption":"","right-text":"Read All News","right-text-link":"","margin-bottom":"40px"}},{"item-type":"item","item-builder-title":"Video","type":"video","option":{"page-item-id":"","title-type":"none","title":"","caption":"","url":"https://vimeo.com/56815898","content-title":"Sollicitudin Sit Inceptos","content":"Donec sed odio dui. Maecenas faucibus mollis interdum. Aenean lacinia bibendum. Vivamus sagittis lacus vel augue laoreet rutrum.","margin-bottom":"60px"}},{"item-type":"item","item-builder-title":"Gallery","type":"gallery","option":{"page-item-id":"","slider":"[[3518,3519,3521,3517,3514,3512,3511,3523,3525],{|gq2|3511|gq2|:{|gq2|title|gq2|:|gq2||gq2|,|gq2|caption|gq2|:|gq2||gq2|,|gq2|caption-position|gq2|:|gq2||gq2|,|gq2|slide-link|gq2|:|gq2|current|gq2|,|gq2|url|gq2|:|gq2||gq2|,|gq2|new-tab|gq2|:|gq2|enable|gq2|,|gq2|thumbnail|gq2|:|gq2|http://themes.goodlayers2.com/hotelmaster/wp-content/uploads/2015/03/photodune-2676493-suite-bed-room-with-balcony-of-a-luxury-resort-m-150x150.jpg|gq2|,|gq2|width|gq2|:150,|gq2|height|gq2|:150},|gq2|3512|gq2|:{|gq2|title|gq2|:|gq2||gq2|,|gq2|caption|gq2|:|gq2||gq2|,|gq2|caption-position|gq2|:|gq2||gq2|,|gq2|slide-link|gq2|:|gq2|current|gq2|,|gq2|url|gq2|:|gq2||gq2|,|gq2|new-tab|gq2|:|gq2|enable|gq2|,|gq2|thumbnail|gq2|:|gq2|http://themes.goodlayers2.com/hotelmaster/wp-content/uploads/2015/03/photodune-3973259-hotel-room-m-150x150.jpg|gq2|,|gq2|width|gq2|:150,|gq2|height|gq2|:150},|gq2|3514|gq2|:{|gq2|title|gq2|:|gq2||gq2|,|gq2|caption|gq2|:|gq2||gq2|,|gq2|caption-position|gq2|:|gq2||gq2|,|gq2|slide-link|gq2|:|gq2|current|gq2|,|gq2|url|gq2|:|gq2||gq2|,|gq2|new-tab|gq2|:|gq2|enable|gq2|,|gq2|thumbnail|gq2|:|gq2|http://themes.goodlayers2.com/hotelmaster/wp-content/uploads/2015/03/photodune-4076311-interior-of-modern-comfortable-hotel-room-m-150x150.jpg|gq2|,|gq2|width|gq2|:150,|gq2|height|gq2|:150},|gq2|3517|gq2|:{|gq2|title|gq2|:|gq2||gq2|,|gq2|caption|gq2|:|gq2||gq2|,|gq2|caption-position|gq2|:|gq2||gq2|,|gq2|slide-link|gq2|:|gq2|current|gq2|,|gq2|url|gq2|:|gq2||gq2|,|gq2|new-tab|gq2|:|gq2|enable|gq2|,|gq2|thumbnail|gq2|:|gq2|http://themes.goodlayers2.com/hotelmaster/wp-content/uploads/2015/03/photodune-2650397-sailing-m-150x150.jpg|gq2|,|gq2|width|gq2|:150,|gq2|height|gq2|:150},|gq2|3518|gq2|:{|gq2|title|gq2|:|gq2||gq2|,|gq2|caption|gq2|:|gq2||gq2|,|gq2|caption-position|gq2|:|gq2||gq2|,|gq2|slide-link|gq2|:|gq2|current|gq2|,|gq2|url|gq2|:|gq2||gq2|,|gq2|new-tab|gq2|:|gq2|enable|gq2|,|gq2|thumbnail|gq2|:|gq2|http://themes.goodlayers2.com/hotelmaster/wp-content/uploads/2015/03/photodune-7751505-luxury-home-with-swimming-pool-m-150x150.jpg|gq2|,|gq2|width|gq2|:150,|gq2|height|gq2|:150},|gq2|3519|gq2|:{|gq2|title|gq2|:|gq2||gq2|,|gq2|caption|gq2|:|gq2||gq2|,|gq2|caption-position|gq2|:|gq2||gq2|,|gq2|slide-link|gq2|:|gq2|current|gq2|,|gq2|url|gq2|:|gq2||gq2|,|gq2|new-tab|gq2|:|gq2|enable|gq2|,|gq2|thumbnail|gq2|:|gq2|http://themes.goodlayers2.com/hotelmaster/wp-content/uploads/2015/03/photodune-1231437-tropical-pool-bar-m-150x150.jpg|gq2|,|gq2|width|gq2|:150,|gq2|height|gq2|:150},|gq2|3521|gq2|:{|gq2|title|gq2|:|gq2||gq2|,|gq2|caption|gq2|:|gq2||gq2|,|gq2|caption-position|gq2|:|gq2||gq2|,|gq2|slide-link|gq2|:|gq2|current|gq2|,|gq2|url|gq2|:|gq2||gq2|,|gq2|new-tab|gq2|:|gq2|enable|gq2|,|gq2|thumbnail|gq2|:|gq2|http://themes.goodlayers2.com/hotelmaster/wp-content/uploads/2015/03/photodune-1576481-relaxing-m-150x150.jpg|gq2|,|gq2|width|gq2|:150,|gq2|height|gq2|:150},|gq2|3523|gq2|:{|gq2|title|gq2|:|gq2||gq2|,|gq2|caption|gq2|:|gq2||gq2|,|gq2|caption-position|gq2|:|gq2||gq2|,|gq2|slide-link|gq2|:|gq2|current|gq2|,|gq2|url|gq2|:|gq2||gq2|,|gq2|new-tab|gq2|:|gq2|enable|gq2|,|gq2|thumbnail|gq2|:|gq2|http://themes.goodlayers2.com/hotelmaster/wp-content/uploads/2015/03/Fotolia_34317913_Subscription_Monthly_XXL-150x150.jpg|gq2|,|gq2|width|gq2|:150,|gq2|height|gq2|:150},|gq2|3525|gq2|:{|gq2|title|gq2|:|gq2||gq2|,|gq2|caption|gq2|:|gq2||gq2|,|gq2|caption-position|gq2|:|gq2||gq2|,|gq2|slide-link|gq2|:|gq2|current|gq2|,|gq2|url|gq2|:|gq2||gq2|,|gq2|new-tab|gq2|:|gq2|enable|gq2|,|gq2|thumbnail|gq2|:|gq2|http://themes.goodlayers2.com/hotelmaster/wp-content/uploads/2015/03/Fotolia_44778217_Subscription_Monthly_XXL-150x150.jpg|gq2|,|gq2|width|gq2|:150,|gq2|height|gq2|:150}}]","title-type":"left-divider","title":"Gallery","caption":"","thumbnail-size":"round-personnel-size","gallery-style":"grid","with-featured":"enable","gallery-columns":"3","num-fetch":"","show-caption":"no","margin-bottom":"20px"}}],"option":{},"size":"1/3"}],"option":{"page-item-id":"","background-type":"color","background":"#ffffff","skin":"no-skin","show-section":"gdlr-show-all","border":"none","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"70px","padding-bottom":"40px"}}]',
					'post-option'=>'{"sidebar":"no-sidebar","left-sidebar":"Footer 1","right-sidebar":"Footer 1","page-style":"normal","show-title":"disable","page-caption":"","show-content":"enable","header-background":""}'
				),
				'homepage-4' => array(
					'above-sidebar'=>'[]',
					'below-sidebar'=>'[]',
					'content-with-sidebar'=>'[{"item-type":"wrapper","item-builder-title":"Full Size Wrapper","type":"full-size-wrapper","items":[{"item-type":"item","item-builder-title":"Master Slider","type":"master-slider","option":{"page-item-id":"","id":"4","margin-bottom":"0px"}}],"option":{"page-item-id":"","background":"#ffffff","show-section":"gdlr-show-all","border":"none","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"0px","padding-bottom":"0px"}},{"item-type":"wrapper","item-builder-title":"Color Wrapper","type":"color-wrapper","items":[{"item-type":"item","item-builder-title":"Hostel Room Availability","type":"hostel-availability","option":{"page-item-id":"","title-type":"center","title":"CHECK AVAILABILITY","caption":"","right-text":"Read All News","right-text-link":"","margin-bottom":"20px"}}],"option":{"page-item-id":"","background-type":"color","background":"#f5f5f5","skin":"gdlr-skin-light-grey","show-section":"gdlr-show-all","border":"none","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"80px","padding-bottom":"50px"}},{"item-type":"wrapper","item-builder-title":"Background/Parallax Wrapper","type":"parallax-bg-wrapper","items":[{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-2","items":[{"item-type":"item","item-builder-title":"Column Service","type":"column-service","option":{"page-item-id":"","type":"image","image":"3957","icon":"","title":"Middle of downtown","style":"type-3","content":"<p>Morbi leo risus, porta ac consectetur ac, vesti bulum at eros. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum.</p>","margin-bottom":"65px"}}],"option":{},"size":"1/3"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-2","items":[{"item-type":"item","item-builder-title":"Column Service","type":"column-service","option":{"page-item-id":"","type":"image","image":"3958","icon":"","title":"Great Environment","style":"type-3","content":"<p>Morbi leo risus, porta ac consectetur ac, vesti bulum at eros. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum.</p>","margin-bottom":"65px"}}],"option":{},"size":"1/3"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-3","items":[{"item-type":"item","item-builder-title":"Column Service","type":"column-service","option":{"page-item-id":"","type":"image","image":"3959","icon":"","title":"Free Breakfast","style":"type-3","content":"<p>Morbi leo risus, porta ac consectetur ac, vesti bulum at eros. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum.</p>","margin-bottom":"65px"}}],"option":{},"size":"1/3"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-3","items":[{"item-type":"item","item-builder-title":"Column Service","type":"column-service","option":{"page-item-id":"","type":"image","image":"3960","icon":"","title":"We Clean Everyday","style":"type-3","content":"<p>Morbi leo risus, porta ac consectetur ac, vesti bulum at eros. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum.</p>","margin-bottom":"65px"}}],"option":{},"size":"1/3"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-3","items":[{"item-type":"item","item-builder-title":"Column Service","type":"column-service","option":{"page-item-id":"","type":"image","image":"3961","icon":"","title":"Enjoy nightlife","style":"type-3","content":"<p>Morbi leo risus, porta ac consectetur ac, vesti bulum at eros. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum.</p>","margin-bottom":"65px"}}],"option":{},"size":"1/3"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-3","items":[{"item-type":"item","item-builder-title":"Column Service","type":"column-service","option":{"page-item-id":"","type":"image","image":"3962","icon":"","title":"Meet New People","style":"type-3","content":"<p>Morbi leo risus, porta ac consectetur ac, vesti bulum at eros. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum.</p>","margin-bottom":"65px"}}],"option":{},"size":"1/3"}],"option":{"page-item-id":"","type":"image","background":"3963","background-mobile":"","background-speed":"0.1","pattern":"1","video":"","video-overlay":"0.5","video-player":"enable","skin":"gdlr-skin-dark-service","show-section":"gdlr-show-all","border":"none","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"95px","padding-bottom":"15px"}},{"item-type":"wrapper","item-builder-title":"Full Size Wrapper","type":"full-size-wrapper","items":[{"item-type":"item","item-builder-title":"Hostel Room","type":"hostel-room","option":{"page-item-id":"","title-type":"center","title":"Dorms & Private Rooms","caption":"","right-text":"View all rooms","right-text-link":"","category":"","tag":"","room-style":"modern-no-space","enable-carousel":"enable","room-size":"3","num-fetch":"6","num-excerpt":"20","thumbnail-size":"blog-grid","orderby":"date","order":"desc","pagination":"disable","margin-bottom":"0px"}}],"option":{"page-item-id":"","background":"#ffffff","show-section":"gdlr-show-all","border":"none","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"70px","padding-bottom":"0px"}},{"item-type":"wrapper","item-builder-title":"Background/Parallax Wrapper","type":"parallax-bg-wrapper","items":[{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-4","items":[{"item-type":"item","item-builder-title":"Skill Item","type":"skill-item","option":{"page-item-id":"","style":"normal","background":"#39dde3","text-color":"#ffffff","title":"2800","caption":"Guests","margin-bottom":"20px"}}],"option":{},"size":"1/4"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-4","items":[{"item-type":"item","item-builder-title":"Skill Item","type":"skill-item","option":{"page-item-id":"","style":"normal","background":"#39dde3","text-color":"#ffffff","title":"35000","caption":"Openning hours","margin-bottom":"20px"}}],"option":{},"size":"1/4"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-4","items":[{"item-type":"item","item-builder-title":"Skill Item","type":"skill-item","option":{"page-item-id":"","style":"normal","background":"#39dde3","text-color":"#ffffff","title":"99.9%","caption":"Satisfaction","margin-bottom":"20px"}}],"option":{},"size":"1/4"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-4","items":[{"item-type":"item","item-builder-title":"Skill Item","type":"skill-item","option":{"page-item-id":"","style":"normal","background":"#39dde3","text-color":"#ffffff","title":"100%","caption":"Will come back","margin-bottom":"20px"}}],"option":{},"size":"1/4"}],"option":{"page-item-id":"","type":"image","background":"3964","background-mobile":"","background-speed":"0.1","pattern":"1","video":"","video-overlay":"0.5","video-player":"enable","skin":"gdlr-skin-dark-skin","show-section":"gdlr-show-all","border":"none","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"190px","padding-bottom":"120px"}},{"item-type":"wrapper","item-builder-title":"Color Wrapper","type":"color-wrapper","items":[{"item-type":"item","item-builder-title":"Testimonial","type":"testimonial","option":{"page-item-id":"","testimonial":"[{|gq2|gdl-tab-author-image-url|gq2|:|gq2||gq2|,|gq2|gdl-tab-author-image|gq2|:|gq2||gq2|,|gq2|gdl-tab-title|gq2|:|gq2|Angelina Cole|gq2|,|gq2|gdl-tab-position|gq2|:|gq2|Traveller|gq2|,|gq2|gdl-tab-content|gq2|:|gq2|Lorem ipsum dolor sit amet, consectetur adipiscing elit. Etiam porta sem malesuada magna mollis euismod. Nul id dolor id nibh ultricies vehicula ut id elit. Nullam quis risus eget urna mollis ornare vel eu leo.|gq2|},{|gq2|gdl-tab-author-image-url|gq2|:|gq2||gq2|,|gq2|gdl-tab-author-image|gq2|:|gq2||gq2|,|gq2|gdl-tab-title|gq2|:|gq2|John Smith|gq2|,|gq2|gdl-tab-position|gq2|:|gq2|Businesman|gq2|,|gq2|gdl-tab-content|gq2|:|gq2|Lorem ipsum dolor sit amet, consectetur adipiscing elit. Etiam porta sem malesuada magna mollis euismod. Nul id dolor id nibh ultricies vehicula ut id elit. Nullam quis risus eget urna mollis ornare vel eu leo. Donec id elit non mi porta.|gq2|},{|gq2|gdl-tab-author-image-url|gq2|:|gq2||gq2|,|gq2|gdl-tab-author-image|gq2|:|gq2||gq2|,|gq2|gdl-tab-title|gq2|:|gq2|Pam Pamelar|gq2|,|gq2|gdl-tab-position|gq2|:|gq2|Traveller|gq2|,|gq2|gdl-tab-content|gq2|:|gq2|Lorem ipsum dolor sit amet, consectetur adipiscing elit. Etiam porta sem malesuada magna mollis euismod. Nul id dolor id nibh ultricies vehicula ut id elit. Nullam quis risus eget urna mollis ornare leo.|gq2|}]","title-type":"center","title":"Testimonial","caption":"","testimonial-columns":"1","testimonial-type":"carousel","testimonial-style":"large plain-style","margin-bottom":"20px"}}],"option":{"page-item-id":"","background-type":"color","background":"#1abc9c","skin":"gdlr-skin-dark-skin","show-section":"gdlr-show-all","border":"none","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"80px","padding-bottom":"45px"}},{"item-type":"wrapper","item-builder-title":"Color Wrapper","type":"color-wrapper","items":[{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-3","items":[{"item-type":"item","item-builder-title":"Gallery","type":"gallery","option":{"page-item-id":"","slider":"[[3518,3519,3521,3517,3514,3512,3511,3523,3525],{|gq2|3511|gq2|:{|gq2|title|gq2|:|gq2||gq2|,|gq2|caption|gq2|:|gq2||gq2|,|gq2|caption-position|gq2|:|gq2||gq2|,|gq2|slide-link|gq2|:|gq2|current|gq2|,|gq2|url|gq2|:|gq2||gq2|,|gq2|new-tab|gq2|:|gq2|enable|gq2|,|gq2|thumbnail|gq2|:|gq2|http://demo.goodlayers.com/hotelmaster/wp-content/uploads/2015/03/photodune-2676493-suite-bed-room-with-balcony-of-a-luxury-resort-m-150x150.jpg|gq2|,|gq2|width|gq2|:150,|gq2|height|gq2|:150},|gq2|3512|gq2|:{|gq2|title|gq2|:|gq2||gq2|,|gq2|caption|gq2|:|gq2||gq2|,|gq2|caption-position|gq2|:|gq2||gq2|,|gq2|slide-link|gq2|:|gq2|current|gq2|,|gq2|url|gq2|:|gq2||gq2|,|gq2|new-tab|gq2|:|gq2|enable|gq2|,|gq2|thumbnail|gq2|:|gq2|http://demo.goodlayers.com/hotelmaster/wp-content/uploads/2015/03/photodune-3973259-hotel-room-m-150x150.jpg|gq2|,|gq2|width|gq2|:150,|gq2|height|gq2|:150},|gq2|3514|gq2|:{|gq2|title|gq2|:|gq2||gq2|,|gq2|caption|gq2|:|gq2||gq2|,|gq2|caption-position|gq2|:|gq2||gq2|,|gq2|slide-link|gq2|:|gq2|current|gq2|,|gq2|url|gq2|:|gq2||gq2|,|gq2|new-tab|gq2|:|gq2|enable|gq2|,|gq2|thumbnail|gq2|:|gq2|http://demo.goodlayers.com/hotelmaster/wp-content/uploads/2015/03/photodune-4076311-interior-of-modern-comfortable-hotel-room-m-150x150.jpg|gq2|,|gq2|width|gq2|:150,|gq2|height|gq2|:150},|gq2|3517|gq2|:{|gq2|title|gq2|:|gq2||gq2|,|gq2|caption|gq2|:|gq2||gq2|,|gq2|caption-position|gq2|:|gq2||gq2|,|gq2|slide-link|gq2|:|gq2|current|gq2|,|gq2|url|gq2|:|gq2||gq2|,|gq2|new-tab|gq2|:|gq2|enable|gq2|,|gq2|thumbnail|gq2|:|gq2|http://demo.goodlayers.com/hotelmaster/wp-content/uploads/2015/03/photodune-2650397-sailing-m-150x150.jpg|gq2|,|gq2|width|gq2|:150,|gq2|height|gq2|:150},|gq2|3518|gq2|:{|gq2|title|gq2|:|gq2||gq2|,|gq2|caption|gq2|:|gq2||gq2|,|gq2|caption-position|gq2|:|gq2||gq2|,|gq2|slide-link|gq2|:|gq2|current|gq2|,|gq2|url|gq2|:|gq2||gq2|,|gq2|new-tab|gq2|:|gq2|enable|gq2|,|gq2|thumbnail|gq2|:|gq2|http://demo.goodlayers.com/hotelmaster/wp-content/uploads/2015/03/photodune-7751505-luxury-home-with-swimming-pool-m-150x150.jpg|gq2|,|gq2|width|gq2|:150,|gq2|height|gq2|:150},|gq2|3519|gq2|:{|gq2|title|gq2|:|gq2||gq2|,|gq2|caption|gq2|:|gq2||gq2|,|gq2|caption-position|gq2|:|gq2||gq2|,|gq2|slide-link|gq2|:|gq2|current|gq2|,|gq2|url|gq2|:|gq2||gq2|,|gq2|new-tab|gq2|:|gq2|enable|gq2|,|gq2|thumbnail|gq2|:|gq2|http://demo.goodlayers.com/hotelmaster/wp-content/uploads/2015/03/photodune-1231437-tropical-pool-bar-m-150x150.jpg|gq2|,|gq2|width|gq2|:150,|gq2|height|gq2|:150},|gq2|3521|gq2|:{|gq2|title|gq2|:|gq2||gq2|,|gq2|caption|gq2|:|gq2||gq2|,|gq2|caption-position|gq2|:|gq2||gq2|,|gq2|slide-link|gq2|:|gq2|current|gq2|,|gq2|url|gq2|:|gq2||gq2|,|gq2|new-tab|gq2|:|gq2|enable|gq2|,|gq2|thumbnail|gq2|:|gq2|http://demo.goodlayers.com/hotelmaster/wp-content/uploads/2015/03/photodune-1576481-relaxing-m-150x150.jpg|gq2|,|gq2|width|gq2|:150,|gq2|height|gq2|:150},|gq2|3523|gq2|:{|gq2|title|gq2|:|gq2||gq2|,|gq2|caption|gq2|:|gq2||gq2|,|gq2|caption-position|gq2|:|gq2||gq2|,|gq2|slide-link|gq2|:|gq2|current|gq2|,|gq2|url|gq2|:|gq2||gq2|,|gq2|new-tab|gq2|:|gq2|enable|gq2|,|gq2|thumbnail|gq2|:|gq2|http://demo.goodlayers.com/hotelmaster/wp-content/uploads/2015/03/Fotolia_34317913_Subscription_Monthly_XXL-150x150.jpg|gq2|,|gq2|width|gq2|:150,|gq2|height|gq2|:150},|gq2|3525|gq2|:{|gq2|title|gq2|:|gq2||gq2|,|gq2|caption|gq2|:|gq2||gq2|,|gq2|caption-position|gq2|:|gq2||gq2|,|gq2|slide-link|gq2|:|gq2|current|gq2|,|gq2|url|gq2|:|gq2||gq2|,|gq2|new-tab|gq2|:|gq2|enable|gq2|,|gq2|thumbnail|gq2|:|gq2|http://demo.goodlayers.com/hotelmaster/wp-content/uploads/2015/03/Fotolia_44778217_Subscription_Monthly_XXL-150x150.jpg|gq2|,|gq2|width|gq2|:150,|gq2|height|gq2|:150}}]","title-type":"left-divider","title":"Gallery","caption":"","thumbnail-size":"small-grid-size-2","gallery-style":"grid","with-featured":"enable","gallery-columns":"4","num-fetch":"","show-caption":"no","margin-bottom":"20px"}}],"option":{},"size":"1/2"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-3","items":[{"item-type":"item","item-builder-title":"Blog","type":"blog","option":{"page-item-id":"","title-type":"left-divider","title":"News From Us","caption":"","right-text":"Read All News","right-text-link":"http://demo.goodlayers.com/hotelmaster/hostel/blog-full-with-right-sidebar/","category":"blog","tag":"","num-excerpt":"17","num-fetch":"3","blog-style":"blog-widget","blog-layout":"fitRows","thumbnail-size":"thumbnail","orderby":"date","order":"desc","offset":"","pagination":"disable","enable-sticky":"disable","margin-bottom":"0px"}}],"option":{},"size":"1/2"}],"option":{"page-item-id":"","background-type":"","background":"#ffffff","skin":"","show-section":"","border":"","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"70px","padding-bottom":"40px"}}]',
					'post-option'=>'{"sidebar":"no-sidebar","left-sidebar":"Footer 1","right-sidebar":"Footer 1","page-style":"normal","show-title":"disable","page-caption":"","show-content":"enable","header-background":""}'
				),
				'homepage-5' => array(
					'above-sidebar'=>'[]',
					'below-sidebar'=>'[]',
					'content-with-sidebar'=>'[{"item-type":"wrapper","item-builder-title":"Full Size Wrapper","type":"full-size-wrapper","items":[{"item-type":"item","item-builder-title":"Master Slider","type":"master-slider","option":{"page-item-id":"","id":"6","margin-bottom":"0px"}}],"option":{"page-item-id":"","background":"#ffffff","show-section":"gdlr-show-all","border":"none","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"0px","padding-bottom":"0px"}},{"item-type":"wrapper","item-builder-title":"Background/Parallax Wrapper","type":"parallax-bg-wrapper","items":[{"item-type":"item","item-builder-title":"Hotel Room Availability","type":"hotel-availability","option":{"page-item-id":"","title-type":"left","title":"Check Availability","caption":"","right-text":"Read All News","right-text-link":"","margin-bottom":"20px"}}],"option":{"page-item-id":"","type":"image","background":"4256","background-mobile":"","background-speed":"0","pattern":"1","video":"","video-overlay":"0.5","video-player":"enable","skin":"gdlr-skin-dark-skin","show-section":"gdlr-show-all","border":"none","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"90px","padding-bottom":"76px"}},{"item-type":"wrapper","item-builder-title":"Color Wrapper","type":"color-wrapper","items":[{"item-type":"item","item-builder-title":"Hotel Room","type":"room","option":{"page-item-id":"","title-type":"left","title":"Our Apartments","caption":"","right-text":"View All","right-text-link":"http://demo.goodlayers.com/hotelmaster/myapartment/?booking","category":"room","tag":"","room-style":"medium-new","enable-carousel":"enable","room-size":"3","num-fetch":"6","num-excerpt":"60","thumbnail-size":"room-thumbnail","orderby":"date","order":"desc","pagination":"disable","margin-bottom":"0px"}}],"option":{"page-item-id":"","background-type":"color","background":"#f3f3f3","skin":"no-skin","show-section":"gdlr-show-all","border":"none","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"72px","padding-bottom":"0px"}},{"item-type":"wrapper","item-builder-title":"Background/Parallax Wrapper","type":"parallax-bg-wrapper","items":[{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-2","items":[{"item-type":"item","item-builder-title":"Column Service","type":"column-service","option":{"page-item-id":"","type":"image","image":"4261","icon":"","title":"Middle of downtown","style":"type-3","content":"<p>Morbi leo risus, porta ac consectetur ac, vesti bulum at eros. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum.</p>","margin-bottom":"65px"}}],"option":{},"size":"1/3"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-2","items":[{"item-type":"item","item-builder-title":"Column Service","type":"column-service","option":{"page-item-id":"","type":"image","image":"3960","icon":"","title":"Clean accomodation","style":"type-3","content":"<p>Morbi leo risus, porta ac consectetur ac, vesti bulum at eros. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum.</p>","margin-bottom":"65px"}}],"option":{},"size":"1/3"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-3","items":[{"item-type":"item","item-builder-title":"Column Service","type":"column-service","option":{"page-item-id":"","type":"image","image":"4262","icon":"","title":"Free airport transfer","style":"type-3","content":"<p>Morbi leo risus, porta ac consectetur ac, vesti bulum at eros. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum.</p>","margin-bottom":"65px"}}],"option":{},"size":"1/3"}],"option":{"page-item-id":"","type":"image","background":"4263","background-mobile":"","background-speed":"0.2","pattern":"1","video":"","video-overlay":"0.5","video-player":"enable","skin":"gdlr-skin-dark-service","show-section":"gdlr-show-all","border":"none","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"100px","padding-bottom":"20px"}},{"item-type":"wrapper","item-builder-title":"Color Wrapper","type":"color-wrapper","items":[{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-3","items":[{"item-type":"item","item-builder-title":"Blog","type":"blog","option":{"page-item-id":"","title-type":"left-divider","title":"News From Us","caption":"","right-text":"Read All News","right-text-link":"http://demo.goodlayers.com/hotelmaster/hostel/blog-full-with-right-sidebar/","category":"blog","tag":"","num-excerpt":"17","num-fetch":"3","blog-style":"blog-widget-2","blog-layout":"fitRows","thumbnail-size":"thumbnail","orderby":"date","order":"desc","offset":"","pagination":"disable","enable-sticky":"disable","margin-bottom":"0px"}}],"option":{},"size":"1/2"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-3","items":[{"item-type":"item","item-builder-title":"Gallery","type":"gallery","option":{"page-item-id":"","slider":"[[3518,3519,3521,3517,3514,3512,3511,3523,3525],{|gq2|3511|gq2|:{|gq2|title|gq2|:|gq2||gq2|,|gq2|caption|gq2|:|gq2||gq2|,|gq2|caption-position|gq2|:|gq2||gq2|,|gq2|slide-link|gq2|:|gq2|current|gq2|,|gq2|url|gq2|:|gq2||gq2|,|gq2|new-tab|gq2|:|gq2|enable|gq2|,|gq2|thumbnail|gq2|:|gq2|http://demo.goodlayers.com/hotelmaster/wp-content/uploads/2015/03/photodune-2676493-suite-bed-room-with-balcony-of-a-luxury-resort-m-150x150.jpg|gq2|,|gq2|width|gq2|:150,|gq2|height|gq2|:150},|gq2|3512|gq2|:{|gq2|title|gq2|:|gq2||gq2|,|gq2|caption|gq2|:|gq2||gq2|,|gq2|caption-position|gq2|:|gq2||gq2|,|gq2|slide-link|gq2|:|gq2|current|gq2|,|gq2|url|gq2|:|gq2||gq2|,|gq2|new-tab|gq2|:|gq2|enable|gq2|,|gq2|thumbnail|gq2|:|gq2|http://demo.goodlayers.com/hotelmaster/wp-content/uploads/2015/03/photodune-3973259-hotel-room-m-150x150.jpg|gq2|,|gq2|width|gq2|:150,|gq2|height|gq2|:150},|gq2|3514|gq2|:{|gq2|title|gq2|:|gq2||gq2|,|gq2|caption|gq2|:|gq2||gq2|,|gq2|caption-position|gq2|:|gq2||gq2|,|gq2|slide-link|gq2|:|gq2|current|gq2|,|gq2|url|gq2|:|gq2||gq2|,|gq2|new-tab|gq2|:|gq2|enable|gq2|,|gq2|thumbnail|gq2|:|gq2|http://demo.goodlayers.com/hotelmaster/wp-content/uploads/2015/03/photodune-4076311-interior-of-modern-comfortable-hotel-room-m-150x150.jpg|gq2|,|gq2|width|gq2|:150,|gq2|height|gq2|:150},|gq2|3517|gq2|:{|gq2|title|gq2|:|gq2||gq2|,|gq2|caption|gq2|:|gq2||gq2|,|gq2|caption-position|gq2|:|gq2||gq2|,|gq2|slide-link|gq2|:|gq2|current|gq2|,|gq2|url|gq2|:|gq2||gq2|,|gq2|new-tab|gq2|:|gq2|enable|gq2|,|gq2|thumbnail|gq2|:|gq2|http://demo.goodlayers.com/hotelmaster/wp-content/uploads/2015/03/photodune-2650397-sailing-m-150x150.jpg|gq2|,|gq2|width|gq2|:150,|gq2|height|gq2|:150},|gq2|3518|gq2|:{|gq2|title|gq2|:|gq2||gq2|,|gq2|caption|gq2|:|gq2||gq2|,|gq2|caption-position|gq2|:|gq2||gq2|,|gq2|slide-link|gq2|:|gq2|current|gq2|,|gq2|url|gq2|:|gq2||gq2|,|gq2|new-tab|gq2|:|gq2|enable|gq2|,|gq2|thumbnail|gq2|:|gq2|http://demo.goodlayers.com/hotelmaster/wp-content/uploads/2015/03/photodune-7751505-luxury-home-with-swimming-pool-m-150x150.jpg|gq2|,|gq2|width|gq2|:150,|gq2|height|gq2|:150},|gq2|3519|gq2|:{|gq2|title|gq2|:|gq2||gq2|,|gq2|caption|gq2|:|gq2||gq2|,|gq2|caption-position|gq2|:|gq2||gq2|,|gq2|slide-link|gq2|:|gq2|current|gq2|,|gq2|url|gq2|:|gq2||gq2|,|gq2|new-tab|gq2|:|gq2|enable|gq2|,|gq2|thumbnail|gq2|:|gq2|http://demo.goodlayers.com/hotelmaster/wp-content/uploads/2015/03/photodune-1231437-tropical-pool-bar-m-150x150.jpg|gq2|,|gq2|width|gq2|:150,|gq2|height|gq2|:150},|gq2|3521|gq2|:{|gq2|title|gq2|:|gq2||gq2|,|gq2|caption|gq2|:|gq2||gq2|,|gq2|caption-position|gq2|:|gq2||gq2|,|gq2|slide-link|gq2|:|gq2|current|gq2|,|gq2|url|gq2|:|gq2||gq2|,|gq2|new-tab|gq2|:|gq2|enable|gq2|,|gq2|thumbnail|gq2|:|gq2|http://demo.goodlayers.com/hotelmaster/wp-content/uploads/2015/03/photodune-1576481-relaxing-m-150x150.jpg|gq2|,|gq2|width|gq2|:150,|gq2|height|gq2|:150},|gq2|3523|gq2|:{|gq2|title|gq2|:|gq2||gq2|,|gq2|caption|gq2|:|gq2||gq2|,|gq2|caption-position|gq2|:|gq2||gq2|,|gq2|slide-link|gq2|:|gq2|current|gq2|,|gq2|url|gq2|:|gq2||gq2|,|gq2|new-tab|gq2|:|gq2|enable|gq2|,|gq2|thumbnail|gq2|:|gq2|http://demo.goodlayers.com/hotelmaster/wp-content/uploads/2015/03/Fotolia_34317913_Subscription_Monthly_XXL-150x150.jpg|gq2|,|gq2|width|gq2|:150,|gq2|height|gq2|:150},|gq2|3525|gq2|:{|gq2|title|gq2|:|gq2||gq2|,|gq2|caption|gq2|:|gq2||gq2|,|gq2|caption-position|gq2|:|gq2||gq2|,|gq2|slide-link|gq2|:|gq2|current|gq2|,|gq2|url|gq2|:|gq2||gq2|,|gq2|new-tab|gq2|:|gq2|enable|gq2|,|gq2|thumbnail|gq2|:|gq2|http://demo.goodlayers.com/hotelmaster/wp-content/uploads/2015/03/Fotolia_44778217_Subscription_Monthly_XXL-150x150.jpg|gq2|,|gq2|width|gq2|:150,|gq2|height|gq2|:150}}]","title-type":"left-divider","title":"Gallery","caption":"","thumbnail-size":"small-grid-size-2","gallery-style":"grid","with-featured":"enable","gallery-columns":"4","num-fetch":"","show-caption":"no","margin-bottom":"20px"}}],"option":{},"size":"1/2"}],"option":{"page-item-id":"","background-type":"","background":"#ffffff","skin":"","show-section":"","border":"","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"70px","padding-bottom":"40px"}},{"item-type":"wrapper","item-builder-title":"Background/Parallax Wrapper","type":"parallax-bg-wrapper","items":[{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-3","items":[],"option":{},"size":"1/5"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-3","items":[{"item-type":"item","item-builder-title":"Title","type":"title","option":{"page-item-id":"","title-type":"center-divider","title":"A little About us","caption":"Inspiration can be found everywhere","right-text":"Read All News","right-text-link":"","margin-bottom":"20px"}},{"item-type":"item","item-builder-title":"Content","type":"content","option":{"page-item-id":"","title-type":"none","title":"","caption":"","right-text":"Read All News","right-text-link":"","content":"<p style=|gq2|text-align: center;|gq2|>Morbi leo risus, porta ac consectetur ac, vestibulum at eros. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh, ut fermentum massa justo sit amet risus. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Donec id elit non mi porta gravida at eget metus. Praesent commodo cursus magna, vel scelerisque nisl conse.</p>","margin-bottom":"20px"}}],"option":{},"size":"3/5"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-3","items":[],"option":{},"size":"1/5"}],"option":{"page-item-id":"","type":"image","background":"4303","background-mobile":"","background-speed":"0.15","pattern":"1","video":"","video-overlay":"0.5","video-player":"enable","skin":"gdlr-skin-dark-skin","show-section":"gdlr-show-all","border":"none","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"155px","padding-bottom":"100px"}},{"item-type":"wrapper","item-builder-title":"Color Wrapper","type":"color-wrapper","items":[{"item-type":"item","item-builder-title":"Testimonial","type":"testimonial","option":{"page-item-id":"","testimonial":"[{|gq2|gdl-tab-author-image-url|gq2|:|gq2||gq2|,|gq2|gdl-tab-author-image|gq2|:|gq2||gq2|,|gq2|gdl-tab-title|gq2|:|gq2|Angelina Cole|gq2|,|gq2|gdl-tab-position|gq2|:|gq2|Traveller|gq2|,|gq2|gdl-tab-content|gq2|:|gq2|Lorem ipsum dolor sit amet, consectetur adipiscing elit. Etiam porta sem malesuada magna mollis euismod. Nul id dolor id nibh ultricies vehicula ut id elit. Nullam quis risus eget urna mollis ornare vel eu leo.|gq2|},{|gq2|gdl-tab-author-image-url|gq2|:|gq2||gq2|,|gq2|gdl-tab-author-image|gq2|:|gq2||gq2|,|gq2|gdl-tab-title|gq2|:|gq2|John Smith|gq2|,|gq2|gdl-tab-position|gq2|:|gq2|Businesman|gq2|,|gq2|gdl-tab-content|gq2|:|gq2|Lorem ipsum dolor sit amet, consectetur adipiscing elit. Etiam porta sem malesuada magna mollis euismod. Nul id dolor id nibh ultricies vehicula ut id elit. Nullam quis risus eget urna mollis ornare vel eu leo. Donec id elit non mi porta.|gq2|},{|gq2|gdl-tab-author-image-url|gq2|:|gq2||gq2|,|gq2|gdl-tab-author-image|gq2|:|gq2||gq2|,|gq2|gdl-tab-title|gq2|:|gq2|Pam Pamelar|gq2|,|gq2|gdl-tab-position|gq2|:|gq2|Traveller|gq2|,|gq2|gdl-tab-content|gq2|:|gq2|Lorem ipsum dolor sit amet, consectetur adipiscing elit. Etiam porta sem malesuada magna mollis euismod. Nul id dolor id nibh ultricies vehicula ut id elit. Nullam quis risus eget urna mollis ornare leo.|gq2|}]","title-type":"center","title":"Testimonial","caption":"","testimonial-columns":"1","testimonial-type":"carousel","testimonial-style":"large plain-style","margin-bottom":"20px"}}],"option":{"page-item-id":"","background-type":"color","background":"#f1ab42","skin":"gdlr-skin-service-testimonial","show-section":"gdlr-show-all","border":"none","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"80px","padding-bottom":"45px"}}]',
					'post-option'=>'{"sidebar":"no-sidebar","left-sidebar":"Footer 1","right-sidebar":"Footer 1","page-style":"normal","show-title":"disable","page-caption":"","show-content":"enable","header-background":"","header-style":"default"}'
				),
				'about' => array(
					'above-sidebar'=>'[]',
					'below-sidebar'=>'[]',
					'content-with-sidebar'=>'[{"item-type":"wrapper","item-builder-title":"Color Wrapper","type":"color-wrapper","items":[{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-2","items":[{"item-type":"item","item-builder-title":"Column Service","type":"column-service","option":{"page-item-id":"","type":"icon","image":"","icon":"","title":"Tortor Tellus Cras","style":"type-1","content":"<p>Aenean lacinia bibendum nulla sed consectetur. Fusce dapibus, tellus ac cursus commodo, tortor mauris condi mentum nibh.</p>","margin-bottom":"20px"}}],"option":{},"size":"1/3"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-4","items":[{"item-type":"item","item-builder-title":"Column Service","type":"column-service","option":{"page-item-id":"","type":"icon","image":"","icon":"","title":"Dolor Fusce Ligula","style":"type-1","content":"<p>Aenean lacinia bibendum nulla sed consectetur. Fusce dapibus, tellus ac cursus commodo, tortor mauris condi mentum nibh.</p>","margin-bottom":"20px"}}],"option":{},"size":"1/3"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-4","items":[{"item-type":"item","item-builder-title":"Column Service","type":"column-service","option":{"page-item-id":"","type":"icon","image":"","icon":"","title":"Inceptos Dolor Mollis","style":"type-1","content":"<p>Aenean lacinia bibendum nulla sed consectetur. Fusce dapibus, tellus ac cursus commodo, tortor mauris condi mentum nibh.</p>","margin-bottom":"20px"}}],"option":{},"size":"1/3"}],"option":{"page-item-id":"","background-type":"color","background":"#ffffff","skin":"no-skin","show-section":"gdlr-show-all","border":"none","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"65px","padding-bottom":"25px"}},{"item-type":"wrapper","item-builder-title":"Background/Parallax Wrapper","type":"parallax-bg-wrapper","items":[{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-2","items":[{"item-type":"item","item-builder-title":"Feature Media","type":"feature-media","option":{"page-item-id":"","type":"image","video-url":"","image":"","thumbnail-size":"thumbnail","title-type":"left","title":"Story About US","caption":"","align":"left","content":"<p>Cras mattis consectetur purus sit amet fermentum. Etiam porta sem malesuada magna mollis euismod. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Maecenas sed diam eget risus varius blandit sit amet non magna.Cras justo odio, dapibus ac facilisis in.Vivamus sagittis lacus vel augue laoreet rutrum faucibus dolor auctor.Nullam quis risus eget urna mollis ornare vel eu leo. Maecenas sed diam eget risus varius blandit sit amet non magna. Cras mattis consectetur purus sit amet fermentum. Morbi leo risus, porta ac consectetur ac, vestibulum at eros. Morbi leo risus, porta ac consectetur ac, vestibulum at eros. Vivamus sagittis lacus vel augue laoreet rutrum.</p>","button-text":"Learn More","button-link":"","margin-bottom":"20px"}}],"option":{},"size":"1/2"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-2","items":[{"item-type":"item","item-builder-title":"Content","type":"content","option":{"page-item-id":"","title-type":"none","title":"","caption":"","right-text":"Read All News","right-text-link":"","content":"","margin-bottom":"80px"}},{"item-type":"item","item-builder-title":"Skill Bar","type":"skill-bar","option":{"page-item-id":"","content":"Social Networks","percent":"100","size":"small","icon":"icon-picture","text-color":"#ffffff","background-color":"#e9e9e9","progress-color":"#b89f80","margin-bottom":"40px"}},{"item-type":"item","item-builder-title":"Skill Bar","type":"skill-bar","option":{"page-item-id":"","content":"Business Planning","percent":"80","size":"small","icon":"icon-code","text-color":"#ffffff","background-color":"#e9e9e9","progress-color":"#b89f80","margin-bottom":"40px"}},{"item-type":"item","item-builder-title":"Skill Bar","type":"skill-bar","option":{"page-item-id":"","content":"Art & Design","percent":"85","size":"small","icon":"","text-color":"#ffffff","background-color":"#e9e9e9","progress-color":"#b89f80","margin-bottom":"40px"}}],"option":{},"size":"1/2"}],"option":{"page-item-id":"","type":"image","background":"3581","background-mobile":"","background-speed":"0.2","pattern":"1","video":"","video-overlay":"0.5","video-player":"enable","skin":"gdlr-skin-dark-skin","show-section":"gdlr-show-all","border":"none","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"90px","padding-bottom":"50px"}},{"item-type":"wrapper","item-builder-title":"Color Wrapper","type":"color-wrapper","items":[{"item-type":"wrapper","item-builder-title":"Column Item","type":"column2-5","items":[{"item-type":"item","item-builder-title":"Content","type":"content","option":{"page-item-id":"","title-type":"none","title":"","caption":"","right-text":"Read All News","right-text-link":"","content":"","margin-bottom":"0px"}},{"item-type":"item","item-builder-title":"Image / Frame","type":"image-frame","option":{"page-item-id":"","image-id":"3714","thumbnail-size":"full","link-type":"none","url":"","frame-type":"none","frame-background":"#dddddd","margin-bottom":"20px"}}],"option":{},"size":"2/5"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column2-5","items":[{"item-type":"item","item-builder-title":"List With Icon","type":"icon-with-list","option":{"page-item-id":"","icon-with-list":"[{|gq2|gdl-tab-icon|gq2|:|gq2|fa-rotate-right|gq2|,|gq2|gdl-tab-title|gq2|:|gq2|Condimentum Porta Aenean|gq2|,|gq2|gdl-tab-content|gq2|:|gq2|Cras justo odio, dapibus ac facilisis in, egestas eget quam. Integer posuere erat a ante venenatis dapibus posuere velit aliquet. Praesent commodo cursus magna, vel scelerisque nisl consectetur et. Cum sociis natoque penatibus et magnis dis parturient montes.|gq2|},{|gq2|gdl-tab-icon|gq2|:|gq2|fa-circle-o-notch|gq2|,|gq2|gdl-tab-title|gq2|:|gq2|Etiam Justo Ullamcorper|gq2|,|gq2|gdl-tab-content|gq2|:|gq2|Cras justo odio, dapibus ac facilisis in, egestas eget quam. Integer posuere erat a ante venenatis dapibus posuere velit aliquet. Praesent commodo cursus magna, vel scelerisque nisl consectetur et. Cum sociis natoque penatibus et magnis dis parturient montes.|gq2|},{|gq2|gdl-tab-icon|gq2|:|gq2|fa-heart-o|gq2|,|gq2|gdl-tab-title|gq2|:|gq2|Inceptos Vulputate Fusce|gq2|,|gq2|gdl-tab-content|gq2|:|gq2|Cras justo odio, dapibus ac facilisis in, egestas eget quam. Integer posuere erat a ante venenatis dapibus posuere velit aliquet. Praesent commodo cursus magna, vel scelerisque nisl consectetur et. Cum sociis natoque penatibus et magnis dis parturient montes.|gq2|},{|gq2|gdl-tab-icon|gq2|:|gq2|fa-star-o|gq2|,|gq2|gdl-tab-title|gq2|:|gq2|Dapibus Mattis Parturient|gq2|,|gq2|gdl-tab-content|gq2|:|gq2|Cras justo odio, dapibus ac facilisis in, egestas eget quam. Integer posuere erat a ante venenatis dapibus posuere velit aliquet. Praesent commodo cursus magna, vel scelerisque nisl consectetur et. Cum sociis natoque penatibus et magnis dis parturient montes.|gq2|}]","title-type":"none","title":"","caption":"","align":"left","margin-bottom":"20px"}}],"option":{},"size":"3/5"}],"option":{"page-item-id":"","background-type":"color","background":"#f4f4f4","skin":"no-skin","show-section":"gdlr-show-all","border":"none","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"115px","padding-bottom":"65px"}},{"item-type":"wrapper","item-builder-title":"Color Wrapper","type":"color-wrapper","items":[{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-3","items":[{"item-type":"item","item-builder-title":"Content","type":"content","option":{"page-item-id":"","title-type":"none","title":"","caption":"","right-text":"Read All News","right-text-link":"","content":"<div style=|gq2|text-align: right; margin-right: 30px; margin-top: 33px;|gq2|>[gdlr_icon type=|gq2|fa-bell|gq2| size=|gq2|58px|gq2| color=|gq2|#ffffff|gq2|]</div>","margin-bottom":"20px"}}],"option":{},"size":"1/5"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-3","items":[{"item-type":"item","item-builder-title":"Stunning Text","type":"stunning-text","option":{"page-item-id":"","title":"Commodo Tellus Sit Sem","caption":"Nullam id dolor id nibh ultricies vehicula ut id elit. Aenean lacinia bibendum nulla sed consectetur. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Donec sed odio dui. Donec sed odio dui. Morbi leo risus, porta ac consectetur ac, vestibulum at eros. Curabitur blandit tempus porttitor. Vestibulum id ligula porta felis euismod semper. ","button-text":"Buy Now","button-link":"","style":"normal","margin-bottom":"20px"}}],"option":{},"size":"4/5"}],"option":{"page-item-id":"","background-type":"color","background":"#b89f80","skin":"gdlr-skin-dark-skin","show-section":"gdlr-show-all","border":"none","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"90px","padding-bottom":"60px"}}]',
					'post-option'=>'{"sidebar":"no-sidebar","left-sidebar":"blog","right-sidebar":"blog","page-style":"normal","show-title":"enable","page-caption":"Example Of About Us Page","show-content":"enable","header-background":""}'
				),
				'contact-1' => array(
					'above-sidebar'=>'[{"item-type":"wrapper","item-builder-title":"Full Size Wrapper","type":"full-size-wrapper","items":[{"item-type":"item","item-builder-title":"Content","type":"content","option":{"page-item-id":"","title-type":"none","title":"","caption":"","right-text":"Read All News","right-text-link":"","content":"<p>[put_wpgm id=1]</p>","margin-bottom":"0px"}}],"option":{"page-item-id":"","background":"#ffffff","show-section":"gdlr-show-all","border":"none","border-top-color":"#dddddd","border-bottom-color":"#dddddd","padding-top":"0px","padding-bottom":"0px"}}]',
					'below-sidebar'=>'[{"item-type":"wrapper","item-builder-title":"Background/Parallax Wrapper","type":"parallax-bg-wrapper","items":[{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-2","items":[{"item-type":"item","item-builder-title":"Box Icon","type":"box-icon-item","option":{"page-item-id":"","icon":"fa-envelope","icon-position":"top","icon-type":"circle","icon-color":"#ffffff","icon-background":"#b89f80","title":"Contact By Email","content":"<p>Lorem ipsum dolor sit amet, consectetur adipisici elit, sed eiusmod tempor incidunt ut labore et dolore magna aliqua.</p>","margin-bottom":"20px"}}],"option":{},"size":"1/3"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-2","items":[{"item-type":"item","item-builder-title":"Box Icon","type":"box-icon-item","option":{"page-item-id":"","icon":"fa-phone","icon-position":"top","icon-type":"circle","icon-color":"#ffffff","icon-background":"#b89f80","title":"Contact By Phone","content":"<p>Lorem ipsum dolor sit amet, consectetur adipisici elit, sed eiusmod tempor incidunt ut labore et dolore magna aliqua.</p>","margin-bottom":"20px"}}],"option":{},"size":"1/3"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-3","items":[{"item-type":"item","item-builder-title":"Box Icon","type":"box-icon-item","option":{"page-item-id":"","icon":"fa-home","icon-position":"top","icon-type":"circle","icon-color":"#ffffff","icon-background":"#b89f80","title":"Come To See Us","content":"<p>Lorem ipsum dolor sit amet, consectetur adipisici elit, sed eiusmod tempor incidunt ut labore et dolore magna aliqua.</p>","margin-bottom":"20px"}}],"option":{},"size":"1/3"}],"option":{"page-item-id":"","type":"image","background":"3581","background-mobile":"","background-speed":"0.2","pattern":"1","video":"","video-overlay":"0.5","video-player":"enable","skin":"no-skin","show-section":"gdlr-show-all","border":"none","border-top-color":"#dddddd","border-bottom-color":"#dddddd","padding-top":"100px","padding-bottom":"50px"}}]',
					'content-with-sidebar'=>'[{"item-type":"item","item-builder-title":"Content","type":"content","option":{"page-item-id":"","title-type":"none","title":"","caption":"","right-text":"Read All News","right-text-link":"","content":"<p>[gdlr_space height=|gq2|-22px|gq2|] [gdlr_heading tag=|gq2|h5|gq2| font_weight=|gq2|bold|gq2| ]Please fulfil the form below. [/gdlr_heading] [gdlr_space height=|gq2|25px|gq2|] [contact-form-7 id=|gq2|4|gq2| title=|gq2|Contact form 1|gq2|]</p>","margin-bottom":"60px"}}]',
					'post-option'=>'{"sidebar":"right-sidebar","left-sidebar":"Footer 1","right-sidebar":"contact","page-style":"normal","show-title":"disable","page-caption":"","show-content":"enable","header-background":""}'
				),
				'contact-2' => array(
					'above-sidebar'=>'[]',
					'below-sidebar'=>'[{"item-type":"wrapper","item-builder-title":"Full Size Wrapper","type":"full-size-wrapper","items":[{"item-type":"item","item-builder-title":"Content","type":"content","option":{"page-item-id":"","title-type":"none","title":"","caption":"","right-text":"Read All News","right-text-link":"","content":"<p>[put_wpgm id=1]</p>","margin-bottom":"0px"}}],"option":{"page-item-id":"","background":"#ffffff","show-section":"gdlr-show-all","border":"none","border-top-color":"#d8d8d8","border-bottom-color":"#dddddd","padding-top":"0px","padding-bottom":"0px"}}]',
					'content-with-sidebar'=>'[{"item-type":"item","item-builder-title":"Content","type":"content","option":{"page-item-id":"","title-type":"none","title":"","caption":"","right-text":"Read All News","right-text-link":"","content":"<p>[gdlr_space height=|gq2|-22px|gq2|] [gdlr_heading tag=|gq2|h5|gq2| font_weight=|gq2|bold|gq2| ]Please fulfil the form below.[/gdlr_heading] [gdlr_space height=|gq2|25px|gq2|] [contact-form-7 id=|gq2|4|gq2| title=|gq2|Contact form 1|gq2|]</p>","margin-bottom":"60px"}}]',
					'post-option'=>'{"sidebar":"left-sidebar","left-sidebar":"contact","right-sidebar":"contact","page-style":"normal","show-title":"enable","page-caption":"Aenean eu leo quam. Pellentesque ornare sem.","show-content":"enable","header-background":""}'
				),
				'branches' => array(
					'above-sidebar'=>'[]',
					'below-sidebar'=>'[]',
					'content-with-sidebar'=>'[{"item-type":"wrapper","item-builder-title":"Background/Parallax Wrapper","type":"parallax-bg-wrapper","items":[{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-5","items":[],"option":{},"size":"1/5"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-5","items":[{"item-type":"item","item-builder-title":"Title","type":"title","option":{"page-item-id":"","title-type":"center-divider","title":"About New York Branch","caption":"Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Morbi leo risus, porta ac consectetur ac, vestibulum at eros. Sed posuere consectetur est at lobortis. Donec sed odio dui. Lorem ipsum dolor sit amet.","right-text":"Read All News","right-text-link":"","margin-bottom":"20px"}}],"option":{},"size":"3/5"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-5","items":[],"option":{},"size":"1/5"}],"option":{"page-item-id":"","type":"image","background":"4077","background-mobile":"","background-speed":"0","pattern":"1","video":"","video-overlay":"0.5","video-player":"enable","skin":"gdlr-skin-dark-skin","show-section":"gdlr-show-all","border":"none","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"160px","padding-bottom":"140px"}},{"item-type":"wrapper","item-builder-title":"Color Wrapper","type":"color-wrapper","items":[{"item-type":"item","item-builder-title":"Room","type":"room","option":{"page-item-id":"","title-type":"left-divider","title":"Rooms Of New York Branch","caption":"","right-text":"View all rooms","right-text-link":"","category":"new-york-branch","tag":"","room-style":"classic","enable-carousel":"disable","room-size":"3","num-fetch":"8","num-excerpt":"20","thumbnail-size":"blog-grid","orderby":"date","order":"desc","pagination":"disable","margin-bottom":"30px"}}],"option":{"page-item-id":"","background-type":"color","background":"#ffffff","skin":"no-skin","show-section":"gdlr-show-all","border":"none","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"80px","padding-bottom":"0px"}},{"item-type":"wrapper","item-builder-title":"Color Wrapper","type":"color-wrapper","items":[{"item-type":"item","item-builder-title":"Gallery","type":"gallery","option":{"page-item-id":"","slider":"[[3510,3511,3512,3518,3517,3516,3515,3514,3513,3519,3521,3522],{|gq2|3510|gq2|:{|gq2|title|gq2|:|gq2||gq2|,|gq2|caption|gq2|:|gq2||gq2|,|gq2|caption-position|gq2|:|gq2||gq2|,|gq2|slide-link|gq2|:|gq2|current|gq2|,|gq2|url|gq2|:|gq2||gq2|,|gq2|new-tab|gq2|:|gq2|enable|gq2|,|gq2|thumbnail|gq2|:|gq2|http://themes.goodlayers2.com/hotelmaster/modern/wp-content/uploads/2015/03/photodune-2232283-hotel-room-with-bed-and-wooden-m1-150x150.jpg|gq2|,|gq2|width|gq2|:150,|gq2|height|gq2|:150},|gq2|3511|gq2|:{|gq2|title|gq2|:|gq2||gq2|,|gq2|caption|gq2|:|gq2||gq2|,|gq2|caption-position|gq2|:|gq2||gq2|,|gq2|slide-link|gq2|:|gq2|current|gq2|,|gq2|url|gq2|:|gq2||gq2|,|gq2|new-tab|gq2|:|gq2|enable|gq2|,|gq2|thumbnail|gq2|:|gq2|http://themes.goodlayers2.com/hotelmaster/modern/wp-content/uploads/2015/03/photodune-2676493-suite-bed-room-with-balcony-of-a-luxury-resort-m1-150x150.jpg|gq2|,|gq2|width|gq2|:150,|gq2|height|gq2|:150},|gq2|3512|gq2|:{|gq2|title|gq2|:|gq2||gq2|,|gq2|caption|gq2|:|gq2||gq2|,|gq2|caption-position|gq2|:|gq2||gq2|,|gq2|slide-link|gq2|:|gq2|current|gq2|,|gq2|url|gq2|:|gq2||gq2|,|gq2|new-tab|gq2|:|gq2|enable|gq2|,|gq2|thumbnail|gq2|:|gq2|http://themes.goodlayers2.com/hotelmaster/modern/wp-content/uploads/2015/03/photodune-3973259-hotel-room-m1-150x150.jpg|gq2|,|gq2|width|gq2|:150,|gq2|height|gq2|:150},|gq2|3513|gq2|:{|gq2|title|gq2|:|gq2||gq2|,|gq2|caption|gq2|:|gq2||gq2|,|gq2|caption-position|gq2|:|gq2||gq2|,|gq2|slide-link|gq2|:|gq2|current|gq2|,|gq2|url|gq2|:|gq2||gq2|,|gq2|new-tab|gq2|:|gq2|enable|gq2|,|gq2|thumbnail|gq2|:|gq2|http://themes.goodlayers2.com/hotelmaster/modern/wp-content/uploads/2015/03/photodune-3973289-hotel-room-m1-150x150.jpg|gq2|,|gq2|width|gq2|:150,|gq2|height|gq2|:150},|gq2|3514|gq2|:{|gq2|title|gq2|:|gq2||gq2|,|gq2|caption|gq2|:|gq2||gq2|,|gq2|caption-position|gq2|:|gq2||gq2|,|gq2|slide-link|gq2|:|gq2|current|gq2|,|gq2|url|gq2|:|gq2||gq2|,|gq2|new-tab|gq2|:|gq2|enable|gq2|,|gq2|thumbnail|gq2|:|gq2|http://themes.goodlayers2.com/hotelmaster/modern/wp-content/uploads/2015/03/photodune-4076311-interior-of-modern-comfortable-hotel-room-m1-150x150.jpg|gq2|,|gq2|width|gq2|:150,|gq2|height|gq2|:150},|gq2|3515|gq2|:{|gq2|title|gq2|:|gq2||gq2|,|gq2|caption|gq2|:|gq2||gq2|,|gq2|caption-position|gq2|:|gq2||gq2|,|gq2|slide-link|gq2|:|gq2|current|gq2|,|gq2|url|gq2|:|gq2||gq2|,|gq2|new-tab|gq2|:|gq2|enable|gq2|,|gq2|thumbnail|gq2|:|gq2|http://themes.goodlayers2.com/hotelmaster/modern/wp-content/uploads/2015/03/photodune-1176751-interior-design-of-modern-living-room-m1-150x150.jpg|gq2|,|gq2|width|gq2|:150,|gq2|height|gq2|:150},|gq2|3516|gq2|:{|gq2|title|gq2|:|gq2||gq2|,|gq2|caption|gq2|:|gq2||gq2|,|gq2|caption-position|gq2|:|gq2||gq2|,|gq2|slide-link|gq2|:|gq2|current|gq2|,|gq2|url|gq2|:|gq2||gq2|,|gq2|new-tab|gq2|:|gq2|enable|gq2|,|gq2|thumbnail|gq2|:|gq2|http://themes.goodlayers2.com/hotelmaster/modern/wp-content/uploads/2015/03/photodune-2516147-palm-van-m1-150x150.jpg|gq2|,|gq2|width|gq2|:150,|gq2|height|gq2|:150},|gq2|3517|gq2|:{|gq2|title|gq2|:|gq2||gq2|,|gq2|caption|gq2|:|gq2||gq2|,|gq2|caption-position|gq2|:|gq2||gq2|,|gq2|slide-link|gq2|:|gq2|current|gq2|,|gq2|url|gq2|:|gq2||gq2|,|gq2|new-tab|gq2|:|gq2|enable|gq2|,|gq2|thumbnail|gq2|:|gq2|http://themes.goodlayers2.com/hotelmaster/modern/wp-content/uploads/2015/03/photodune-2650397-sailing-m1-150x150.jpg|gq2|,|gq2|width|gq2|:150,|gq2|height|gq2|:150},|gq2|3518|gq2|:{|gq2|title|gq2|:|gq2||gq2|,|gq2|caption|gq2|:|gq2||gq2|,|gq2|caption-position|gq2|:|gq2||gq2|,|gq2|slide-link|gq2|:|gq2|current|gq2|,|gq2|url|gq2|:|gq2||gq2|,|gq2|new-tab|gq2|:|gq2|enable|gq2|,|gq2|thumbnail|gq2|:|gq2|http://themes.goodlayers2.com/hotelmaster/modern/wp-content/uploads/2015/03/photodune-7751505-luxury-home-with-swimming-pool-m1-150x150.jpg|gq2|,|gq2|width|gq2|:150,|gq2|height|gq2|:150},|gq2|3519|gq2|:{|gq2|title|gq2|:|gq2||gq2|,|gq2|caption|gq2|:|gq2||gq2|,|gq2|caption-position|gq2|:|gq2||gq2|,|gq2|slide-link|gq2|:|gq2|current|gq2|,|gq2|url|gq2|:|gq2||gq2|,|gq2|new-tab|gq2|:|gq2|enable|gq2|,|gq2|thumbnail|gq2|:|gq2|http://themes.goodlayers2.com/hotelmaster/modern/wp-content/uploads/2015/03/photodune-1231437-tropical-pool-bar-m1-150x150.jpg|gq2|,|gq2|width|gq2|:150,|gq2|height|gq2|:150},|gq2|3521|gq2|:{|gq2|title|gq2|:|gq2||gq2|,|gq2|caption|gq2|:|gq2||gq2|,|gq2|caption-position|gq2|:|gq2||gq2|,|gq2|slide-link|gq2|:|gq2|current|gq2|,|gq2|url|gq2|:|gq2||gq2|,|gq2|new-tab|gq2|:|gq2|enable|gq2|,|gq2|thumbnail|gq2|:|gq2|http://themes.goodlayers2.com/hotelmaster/modern/wp-content/uploads/2015/03/photodune-1576481-relaxing-m1-150x150.jpg|gq2|,|gq2|width|gq2|:150,|gq2|height|gq2|:150},|gq2|3522|gq2|:{|gq2|title|gq2|:|gq2||gq2|,|gq2|caption|gq2|:|gq2||gq2|,|gq2|caption-position|gq2|:|gq2||gq2|,|gq2|slide-link|gq2|:|gq2|current|gq2|,|gq2|url|gq2|:|gq2||gq2|,|gq2|new-tab|gq2|:|gq2|enable|gq2|,|gq2|thumbnail|gq2|:|gq2|http://themes.goodlayers2.com/hotelmaster/modern/wp-content/uploads/2015/03/Fotolia_33275049_Subscription_Monthly_XXL1-150x150.jpg|gq2|,|gq2|width|gq2|:150,|gq2|height|gq2|:150}}]","title-type":"left-divider","title":"Hotel Gallery","caption":"","thumbnail-size":"small-grid-size","gallery-style":"grid","with-featured":"disable","gallery-columns":"6","num-fetch":"","show-caption":"yes","margin-bottom":"20px"}}],"option":{"page-item-id":"","background-type":"color","background":"#f5f5f5","skin":"no-skin","show-section":"gdlr-show-all","border":"none","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"75px","padding-bottom":"30px"}},{"item-type":"wrapper","item-builder-title":"Color Wrapper","type":"color-wrapper","items":[{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-2","items":[{"item-type":"item","item-builder-title":"Content","type":"content","option":{"page-item-id":"","title-type":"center","title":"","caption":"","right-text":"Read All News","right-text-link":"","content":"<p style=|gq2|text-align: center; font-size: 22px;|gq2|>[gdlr_icon type=|gq2|fa-location-arrow|gq2| size=|gq2|22px|gq2| color=|gq2|#ffffff|gq2|] 343 Wall Street New York USA</p><p>[gdlr_space height=|gq2|15px|gq2|]</p><p style=|gq2|text-align: center; font-size: 17px;|gq2|>[gdlr_icon type=|gq2|fa-phone|gq2| size=|gq2|17px|gq2| color=|gq2|#ffffff|gq2|] 222-3333-4444</p>","margin-bottom":"20px"}}],"option":{},"size":"1/1"}],"option":{"page-item-id":"","background-type":"color","background":"#2d2d2d","skin":"gdlr-skin-dark-skin","show-section":"gdlr-show-all","border":"none","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"60px","padding-bottom":"40px"}},{"item-type":"wrapper","item-builder-title":"Full Size Wrapper","type":"full-size-wrapper","items":[{"item-type":"item","item-builder-title":"Content","type":"content","option":{"page-item-id":"","title-type":"none","title":"","caption":"","right-text":"Read All News","right-text-link":"","content":"<p>[put_wpgm id=2]</p>","margin-bottom":"0px"}}],"option":{"page-item-id":"","background":"#ffffff","show-section":"gdlr-show-all","border":"none","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"0px","padding-bottom":"0px"}}]',
					'post-option'=>'{"sidebar":"no-sidebar","left-sidebar":"Footer 1","right-sidebar":"Footer 1","page-style":"normal","show-title":"disable","page-caption":"","show-content":"enable","header-background":""}'
				),
				'service-facilities' => array(
					'above-sidebar'=>'[]',
					'below-sidebar'=>'[]',
					'content-with-sidebar'=>'[{"item-type":"wrapper","item-builder-title":"Color Wrapper","type":"color-wrapper","items":[{"item-type":"item","item-builder-title":"Title","type":"title","option":{"page-item-id":"","title-type":"center","title":"Services & Facilities","caption":"","right-text":"Read All News","right-text-link":"","margin-bottom":"0px"}}],"option":{"page-item-id":"","background-type":"color","background":"#ffffff","skin":"no-skin","show-section":"gdlr-show-all","border":"none","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"95px","padding-bottom":"30px"}},{"item-type":"wrapper","item-builder-title":"Color Wrapper","type":"color-wrapper","items":[{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-3","items":[{"item-type":"item","item-builder-title":"Column Service","type":"column-service","option":{"page-item-id":"","type":"icon","image":"","icon":"fa-coffee","title":"Coffee and tea","style":"type-3","content":"<p>Morbi leo risus, porta ac consectetur ac, vesti bulum at eros. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum.</p>","margin-bottom":"50px"}}],"option":{},"size":"1/3"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-3","items":[{"item-type":"item","item-builder-title":"Column Service","type":"column-service","option":{"page-item-id":"","type":"icon","image":"","icon":"fa-book","title":"Bokshelf","style":"type-3","content":"<p>Morbi leo risus, porta ac consectetur ac, vesti bulum at eros. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum.</p>","margin-bottom":"50px"}}],"option":{},"size":"1/3"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-3","items":[{"item-type":"item","item-builder-title":"Column Service","type":"column-service","option":{"page-item-id":"","type":"icon","image":"","icon":"fa-puzzle-piece","title":"Game zone","style":"type-3","content":"<p>Morbi leo risus, porta ac consectetur ac, vesti bulum at eros. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum.</p>","margin-bottom":"50px"}}],"option":{},"size":"1/3"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-3","items":[{"item-type":"item","item-builder-title":"Column Service","type":"column-service","option":{"page-item-id":"","type":"icon","image":"","icon":"fa-music","title":"Music Room","style":"type-3","content":"<p>Morbi leo risus, porta ac consectetur ac, vesti bulum at eros. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum.</p>","margin-bottom":"50px"}}],"option":{},"size":"1/3"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-3","items":[{"item-type":"item","item-builder-title":"Column Service","type":"column-service","option":{"page-item-id":"","type":"icon","image":"","icon":"fa-wifi","title":"Free wifi","style":"type-3","content":"<p>Morbi leo risus, porta ac consectetur ac, vesti bulum at eros. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum.</p>","margin-bottom":"50px"}}],"option":{},"size":"1/3"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-3","items":[{"item-type":"item","item-builder-title":"Column Service","type":"column-service","option":{"page-item-id":"","type":"icon","image":"","icon":"fa-key","title":"Free lockers","style":"type-3","content":"<p>Morbi leo risus, porta ac consectetur ac, vesti bulum at eros. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum.</p>","margin-bottom":"50px"}}],"option":{},"size":"1/3"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-3","items":[{"item-type":"item","item-builder-title":"Column Service","type":"column-service","option":{"page-item-id":"","type":"icon","image":"","icon":"fa-spoon","title":"Kitchen","style":"type-3","content":"<p>Morbi leo risus, porta ac consectetur ac, vesti bulum at eros. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum.</p>","margin-bottom":"50px"}}],"option":{},"size":"1/3"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-3","items":[{"item-type":"item","item-builder-title":"Column Service","type":"column-service","option":{"page-item-id":"","type":"icon","image":"","icon":"fa-desktop","title":"Computers area","style":"type-3","content":"<p>Morbi leo risus, porta ac consectetur ac, vesti bulum at eros. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum.</p>","margin-bottom":"50px"}}],"option":{},"size":"1/3"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-3","items":[{"item-type":"item","item-builder-title":"Column Service","type":"column-service","option":{"page-item-id":"","type":"icon","image":"","icon":"fa-video-camera","title":"Movies/Tv/Lounge","style":"type-3","content":"<p>Morbi leo risus, porta ac consectetur ac, vesti bulum at eros. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum.</p>","margin-bottom":"50px"}}],"option":{},"size":"1/3"}],"option":{"page-item-id":"","background-type":"color","background":"#ffffff","skin":"gdlr-skin-services-amp-facilities","show-section":"gdlr-show-all","border":"none","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"70px","padding-bottom":"30px"}},{"item-type":"wrapper","item-builder-title":"Full Size Wrapper","type":"full-size-wrapper","items":[{"item-type":"item","item-builder-title":"Master Slider","type":"master-slider","option":{"page-item-id":"","id":"5","margin-bottom":"0px"}}],"option":{"page-item-id":"","background":"#ffffff","show-section":"gdlr-show-all","border":"none","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"0px","padding-bottom":"0px"}},{"item-type":"wrapper","item-builder-title":"Color Wrapper","type":"color-wrapper","items":[{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-4","items":[{"item-type":"item","item-builder-title":"Skill Item","type":"skill-item","option":{"page-item-id":"","style":"normal","background":"#39dde3","text-color":"#ffffff","title":"2800","caption":"Guests","margin-bottom":"20px"}}],"option":{},"size":"1/4"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-4","items":[{"item-type":"item","item-builder-title":"Skill Item","type":"skill-item","option":{"page-item-id":"","style":"normal","background":"#39dde3","text-color":"#ffffff","title":"35000","caption":"Opening Hours","margin-bottom":"20px"}}],"option":{},"size":"1/4"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-4","items":[{"item-type":"item","item-builder-title":"Skill Item","type":"skill-item","option":{"page-item-id":"","style":"normal","background":"#39dde3","text-color":"#ffffff","title":"99.9%","caption":"Satisfaction","margin-bottom":"20px"}}],"option":{},"size":"1/4"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-4","items":[{"item-type":"item","item-builder-title":"Skill Item","type":"skill-item","option":{"page-item-id":"","style":"normal","background":"#39dde3","text-color":"#ffffff","title":"100%","caption":"Will come back","margin-bottom":"20px"}}],"option":{},"size":"1/4"}],"option":{"page-item-id":"","background-type":"color","background":"#ffffff","skin":"no-skin","show-section":"gdlr-show-all","border":"none","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"120px","padding-bottom":"95px"}},{"item-type":"wrapper","item-builder-title":"Background/Parallax Wrapper","type":"parallax-bg-wrapper","items":[{"item-type":"item","item-builder-title":"Testimonial","type":"testimonial","option":{"page-item-id":"","testimonial":"[{|gq2|gdl-tab-author-image-url|gq2|:|gq2||gq2|,|gq2|gdl-tab-author-image|gq2|:|gq2||gq2|,|gq2|gdl-tab-title|gq2|:|gq2|Angelina Cole|gq2|,|gq2|gdl-tab-position|gq2|:|gq2|Traveller|gq2|,|gq2|gdl-tab-content|gq2|:|gq2|Lorem ipsum dolor sit amet, consectetur adipiscing elit. Etiam porta sem malesuada magna mollis euismod. <br/>Nul id dolor id nibh ultricies vehicula ut id elit. Nullam quis risus eget urna mollis ornare vel eu leo.|gq2|},{|gq2|gdl-tab-author-image-url|gq2|:|gq2||gq2|,|gq2|gdl-tab-author-image|gq2|:|gq2||gq2|,|gq2|gdl-tab-title|gq2|:|gq2|John Smith|gq2|,|gq2|gdl-tab-position|gq2|:|gq2|Businessman|gq2|,|gq2|gdl-tab-content|gq2|:|gq2|Lorem ipsum dolor sit amet, consectetur adipiscing elit. Etiam porta sem malesuada magna mollis euismod. <br/>Nul id dolor id nibh ultricies vehicula ut id elit. Nullam quis risus eget urna mollis ornare vel eu leo.|gq2|}]","title-type":"center","title":"Testimonial","caption":"","testimonial-columns":"1","testimonial-type":"carousel","testimonial-style":"large plain-style","margin-bottom":"20px"}}],"option":{"page-item-id":"","type":"image","background":"4033","background-mobile":"","background-speed":"0.1","pattern":"1","video":"","video-overlay":"0.5","video-player":"enable","skin":"gdlr-skin-service-testimonial","show-section":"gdlr-show-all","border":"none","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"150px","padding-bottom":"100px"}}]',
					'post-option'=>'{"sidebar":"no-sidebar","left-sidebar":"Footer 1","right-sidebar":"Footer 1","page-style":"normal","show-title":"enable","page-caption":"Page caption here","show-content":"enable","header-background":"","header-style":"default"}'
				),
			);

			$loaded_data = $default_data[$_POST['slug']];
			foreach( $loaded_data as $meta_key => $meta_value ){
				update_post_meta($_POST['post_id'], $meta_key, $meta_value);
			}
		}
	}
?>